#!/usr/bin/python

import selenium
import unittest

class MailerTest(unittest.TestCase):
    siteAppURL = "http://rhel5.sa.plesk.ru/mailer/"
    siteAppAdminURL = siteAppURL + "admin/"
    types = {"user": "admin",
             "password": "123qwe"}
    click = "check"

    def setUp(self):
        self.browser = selenium.selenium("localhost", \
                                         4444, "*firefox", self.siteAppURL)
        self.browser.start()
        
    def test_mailer_auth(self):
        browser = self.browser
        browser.open(self.siteAppAdminURL)
        for k, v in self.types.iteritems():
            browser.type(k, v)
        browser.click(self.click)
        browser.wait_for_page_to_load(5000)
        self.assertEqual("Welcome admin to your administrative area.", browser.get_title())
        
    def tearDown(self):
        self.browser.stop()
        
if __name__ == "__main__":
    unittest.main()             