-- MySQL dump 10.11
--
-- Host: localhost    Database: mailer
-- ------------------------------------------------------
-- Server version	5.0.32-Debian_7etch3-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `auto_responder`
--

DROP TABLE IF EXISTS `auto_responder`;
CREATE TABLE `auto_responder` (
  `responder_id` mediumint(8) unsigned NOT NULL auto_increment,
  `f_id` int(11) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `subject` varchar(255) NOT NULL default '',
  `subscribed` tinyint(3) unsigned NOT NULL default '0',
  `message_format` tinyint(3) unsigned NOT NULL default '0',
  `from_name` varchar(255) NOT NULL default '',
  `from_addr` varchar(255) NOT NULL default '',
  `reply_to` varchar(255) NOT NULL default '',
  `return_path` varchar(255) NOT NULL default '',
  `delay` bigint(20) unsigned NOT NULL default '0',
  `delay_unit` char(1) NOT NULL default 'h',
  `body` text,
  `url` varchar(255) NOT NULL default '',
  `template_id` mediumint(8) unsigned NOT NULL default '0',
  `attach1` mediumblob,
  `attach1_name` varchar(255) NOT NULL default '',
  `attach2` mediumblob,
  `attach2_name` varchar(255) NOT NULL default '',
  `monitor_reads` tinyint(3) unsigned NOT NULL default '1',
  `profile_text` varchar(255) NOT NULL default 'To update your profile, click here %profile%',
  `allow_profile` tinyint(3) unsigned NOT NULL default '0',
  `unsub_text` varchar(255) NOT NULL default 'Click here to unsubscribe %unsub%',
  `allow_unsub` tinyint(3) unsigned NOT NULL default '0',
  `share_email` tinyint(3) unsigned NOT NULL default '1',
  `share_text` varchar(255) NOT NULL default 'Click <a href=%share%>here</a> to share this email with a friend',
  `recipients` mediumint(8) unsigned NOT NULL default '0',
  `added` datetime NOT NULL,
  `is_confirm` enum('false','true') default 'false',
  `show_list` tinyint(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (`responder_id`),
  KEY `indx_added` (`added`),
  KEY `indx_confirm` (`is_confirm`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Auto-responder for the mailing lists';

--
-- Dumping data for table `auto_responder`
--

LOCK TABLES `auto_responder` WRITE;
/*!40000 ALTER TABLE `auto_responder` DISABLE KEYS */;
/*!40000 ALTER TABLE `auto_responder` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `banned_emails`
--

DROP TABLE IF EXISTS `banned_emails`;
CREATE TABLE `banned_emails` (
  `email` varchar(255) NOT NULL,
  `form_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`email`,`form_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Banned Emails';

--
-- Dumping data for table `banned_emails`
--

LOCK TABLES `banned_emails` WRITE;
/*!40000 ALTER TABLE `banned_emails` DISABLE KEYS */;
/*!40000 ALTER TABLE `banned_emails` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `campaigns_categories`
--

DROP TABLE IF EXISTS `campaigns_categories`;
CREATE TABLE `campaigns_categories` (
  `email_id` mediumint(8) unsigned NOT NULL,
  `category_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`email_id`,`category_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Interest Groups of Email Campaigns';

--
-- Dumping data for table `campaigns_categories`
--

LOCK TABLES `campaigns_categories` WRITE;
/*!40000 ALTER TABLE `campaigns_categories` DISABLE KEYS */;
/*!40000 ALTER TABLE `campaigns_categories` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `config`
--

DROP TABLE IF EXISTS `config`;
CREATE TABLE `config` (
  `enable_password_reminder` tinyint(4) NOT NULL default '1',
  `enable_change_info` tinyint(4) NOT NULL default '1',
  `enable_change_password` tinyint(4) NOT NULL default '1',
  `admin_header` mediumblob,
  `admin_header_align` varchar(32) NOT NULL default 'left',
  `admin_footer` mediumblob,
  `admin_footer_align` varchar(32) NOT NULL default 'left',
  `email_sent_date` date NOT NULL default '0000-00-00',
  `email_sent` mediumint(9) NOT NULL default '0',
  `bounce_hard` varchar(32) NOT NULL default 'bounce_ignore',
  `hard_notify` tinyint(3) unsigned NOT NULL default '1',
  `hard_move` mediumint(8) unsigned NOT NULL default '0',
  `bounce_soft` varchar(32) NOT NULL default 'bounce_ignore',
  `soft_notify` tinyint(3) unsigned NOT NULL default '1',
  `soft_move` mediumint(8) unsigned NOT NULL default '0',
  `bounce_success` varchar(32) NOT NULL default 'bounce_ignore',
  `success_notify` tinyint(3) unsigned NOT NULL default '1',
  `success_move` mediumint(8) unsigned NOT NULL default '0',
  `pop_server` varchar(255) NOT NULL default '',
  `pop_user` varchar(255) NOT NULL default '',
  `pop_password` varchar(255) NOT NULL default '',
  `pop_port` varchar(5) NOT NULL default '110',
  `pop_delmail` tinyint(3) unsigned NOT NULL default '1',
  `powered` varchar(255) NOT NULL default '',
  `help` varchar(255) NOT NULL default '',
  `shot1_img` mediumblob,
  `year_start` mediumint(8) unsigned NOT NULL default '2004',
  `year_range` smallint(5) unsigned NOT NULL default '10',
  `flood_protect` tinyint(3) unsigned NOT NULL default '0',
  `spam_tag` varchar(255) NOT NULL default 'SPAM Protection:',
  `server_path` varchar(255) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Common config options';

--
-- Dumping data for table `config`
--

LOCK TABLES `config` WRITE;
/*!40000 ALTER TABLE `config` DISABLE KEYS */;
INSERT INTO `config` VALUES (1,1,1,NULL,'left',NULL,'left','0000-00-00',0,'bounce_ignore',1,0,'bounce_ignore',1,0,'bounce_ignore',1,0,'','','','110',1,'','',NULL,2004,10,0,'SPAM Protection:','@@ROOT_URL@@');
/*!40000 ALTER TABLE `config` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `countries`
--

DROP TABLE IF EXISTS `countries`;
CREATE TABLE `countries` (
  `code` char(2) NOT NULL,
  `name` varchar(32) default NULL,
  PRIMARY KEY  (`code`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Countries of the world';

--
-- Dumping data for table `countries`
--

LOCK TABLES `countries` WRITE;
/*!40000 ALTER TABLE `countries` DISABLE KEYS */;
INSERT INTO `countries` VALUES ('AF','Afghanistan'),('AL','Albania'),('DZ','Algeria'),('AD','Andorra'),('AO','Angola'),('AI','Anguilla'),('AQ','Antarctica'),('AG','Antigua and Barbuda'),('AR','Argentina'),('AM','Armenia'),('AW','Aruba'),('AU','Australia'),('AT','Austria'),('AZ','Azerbaijan'),('BS','Bahamas'),('BH','Bahrain'),('BD','Bangladesh'),('BB','Barbados'),('BY','Belarus'),('BE','Belgium'),('BZ','Belize'),('BJ','Benin'),('BM','Bermuda'),('BT','Bhutan'),('BO','Bolivia'),('BW','Botswana'),('BV','Bouvet Island'),('BR','Brazil'),('IO','British Indian Ocean Territory'),('BN','Brunei'),('BG','Bulgaria'),('BF','Burkina Faso'),('BI','Burundi'),('KH','Cambodia (Kampuchea)'),('CM','Cameroon'),('CA','Canada'),('CV','Cape Verde'),('KY','Cayman Islands'),('CF','Central African Republic'),('TD','Chad'),('CL','Chile'),('CN','China'),('CX','Christmas Island'),('CC','Cocos (Keeling) Islands'),('CO','Colombia'),('KM','Comoro Islands'),('CG','Congo'),('CK','Cook Islands'),('CR','Costa Rica'),('HR','Croatia'),('CU','Cuba'),('CY','Cyprus'),('CZ','Czech Republic'),('DK','Denmark'),('DJ','Djibouti'),('DM','Dominica'),('DO','Dominican Republic'),('EC','Ecuador'),('EG','Egypt'),('SV','El Salvador'),('GQ','Equatorial Guinea'),('EE','Estonia'),('ET','Ethiopia'),('FK','Falkland Islands (Malvinas)'),('FO','Faroe Islands'),('FJ','Fiji'),('FI','Finland'),('FR','France'),('GA','Gabon'),('GM','Gambia'),('GE','Georgia'),('DE','Germany'),('GH','Ghana'),('GI','Gibraltar'),('GR','Greece'),('GL','Greenland'),('GD','Grenada'),('GP','Guadeloupe'),('GU','Guam'),('GT','Guatemala'),('GF','Guiana (French)'),('GN','Guinea'),('GW','Guinea Bissau'),('GY','Guyana'),('HT','Haiti'),('HN','Honduras'),('HK','Hong Kong'),('HU','Hungary'),('IS','Iceland'),('IN','India'),('ID','Indonesia'),('IR','Iran'),('IQ','Iraq'),('IE','Ireland'),('IL','Israel'),('IT','Italy'),('CI','Ivory Coast'),('JM','Jamaica'),('JP','Japan'),('JT','Johnston Island'),('JO','Jordan'),('KZ','Kazakhstan'),('KE','Kenya'),('KI','Kiribati'),('KP','Korea (North)'),('KR','Korea (South)'),('KW','Kuwait'),('KG','Kyrgyzstan'),('LA','Laos'),('LV','Latvia'),('LB','Lebanon'),('LS','Lesotho'),('LR','Liberia'),('LY','Libya'),('LI','Liechtenstein'),('LT','Lithuania'),('LU','Luxembourg'),('MO','Macau'),('MG','Madagascar'),('MW','Malawi'),('MY','Malaysia'),('MV','Maldives'),('ML','Mali'),('MT','Malta'),('MH','Marshall Islands'),('MQ','Martinique'),('MR','Mauritania'),('MU','Mauritius'),('MX','Mexico'),('FM','Micronesia'),('MI','Midway Islands'),('MD','Moldavia'),('MC','Monaco'),('MN','Mongolia'),('MS','Montserrat'),('MA','Morocco'),('MZ','Mozambique'),('MM','Myanmar'),('NA','Namibia'),('NR','Nauru'),('NP','Nepal'),('NL','Netherlands'),('AN','Netherlands Antilles'),('NC','New Caledonia'),('NZ','New Zealand'),('NI','Nicaragua'),('NE','Niger'),('NG','Nigeria'),('NU','Niue'),('NF','Norfolk Island'),('NO','Norway'),('OM','Oman'),('PC','Pacific Islands (US)'),('PK','Pakistan'),('PA','Panama'),('PG','Papua New Guinea'),('PY','Paraguay'),('PE','Peru'),('PH','Philippines'),('PN','Pitcairn Islands'),('PL','Poland'),('PF','Polynesia (French)'),('PT','Portugal'),('PR','Puerto Rico'),('QA','Qatar'),('RE','Reunion'),('RO','Romania'),('RU','Russia'),('RW','Rwanda'),('EH','Sahara (Western)'),('SH','Saint Helena'),('KN','Saint Kitts and Nevis'),('LC','Saint Lucia'),('PM','Saint Pierre and Miquelon'),('VC','Saint Vincent and Grenadines'),('AS','Samoa (American)'),('WS','Samoa (Western)'),('SM','San Marino'),('ST','Sao Tome and Principe'),('SA','Saudi Arabia'),('SN','Senegal'),('SC','Seychelles'),('SL','Sierra Leone'),('SG','Singapore'),('SK','Slovakia'),('SI','Slovenia'),('SB','Solomon Islands'),('SO','Somalia'),('ZA','South Africa'),('ES','Spain'),('LK','Sri Lanka'),('SD','Sudan'),('SR','Surinam'),('SZ','Swaziland'),('SE','Sweden'),('CH','Switzerland'),('SY','Syria'),('TJ','Tadzhikistan'),('TW','Taiwan'),('TZ','Tanzania'),('TH','Thailand'),('TP','Timor (East)'),('TG','Togo'),('TK','Tokelau'),('TO','Tonga'),('TT','Trinidad and Tobago'),('TN','Tunisia'),('TR','Turkey'),('TM','Turkmenistan'),('TC','Turks and Caicos Islands'),('TV','Tuvalu'),('UG','Uganda'),('UA','Ukraine'),('AE','United Arab Emirates'),('GB','United Kingdom'),('US','United States'),('UY','Uruguay'),('UZ','Uzbekistan'),('VU','Vanuatu'),('VA','Vatican'),('VE','Venezuela'),('VN','Vietnam'),('VG','Virgin Islands (British)'),('VI','Virgin Islands (US)'),('WK','Wake Island'),('WF','Wallis and Futuna Islands'),('YE','Yemen'),('YU','Yugoslavia'),('ZR','Zaire'),('ZM','Zambia'),('ZW','Zimbabwe');
/*!40000 ALTER TABLE `countries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cron`
--

DROP TABLE IF EXISTS `cron`;
CREATE TABLE `cron` (
  `id` int(11) NOT NULL auto_increment,
  `start_time` datetime default NULL,
  `end_time` datetime default NULL,
  `is_mailout` tinyint(3) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Cron job detail';

--
-- Dumping data for table `cron`
--

LOCK TABLES `cron` WRITE;
/*!40000 ALTER TABLE `cron` DISABLE KEYS */;
/*!40000 ALTER TABLE `cron` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customize_fields`
--

DROP TABLE IF EXISTS `customize_fields`;
CREATE TABLE `customize_fields` (
  `field_id` smallint(5) unsigned NOT NULL auto_increment,
  `cust_id` tinyint(3) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  `required` tinyint(4) NOT NULL default '0',
  `active` tinyint(4) NOT NULL default '1',
  `search` tinyint(4) NOT NULL default '0',
  `modify` tinyint(4) NOT NULL default '1',
  `type` tinyint(4) NOT NULL default '0',
  `sort` tinyint(3) unsigned NOT NULL default '255',
  `empty_default` tinyint(3) unsigned NOT NULL default '1',
  `date_start` smallint(5) unsigned NOT NULL default '0',
  `date_end` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`field_id`),
  KEY `i_formfld_field` (`cust_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Custom customize_fields';

--
-- Dumping data for table `customize_fields`
--

LOCK TABLES `customize_fields` WRITE;
/*!40000 ALTER TABLE `customize_fields` DISABLE KEYS */;
/*!40000 ALTER TABLE `customize_fields` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customize_list`
--

DROP TABLE IF EXISTS `customize_list`;
CREATE TABLE `customize_list` (
  `cust_id` int(11) NOT NULL auto_increment,
  `name` varchar(64) NOT NULL default '',
  `added` datetime NOT NULL default '0000-00-00 00:00:00',
  `form_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cust_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Customize List Detail';

--
-- Dumping data for table `customize_list`
--

LOCK TABLES `customize_list` WRITE;
/*!40000 ALTER TABLE `customize_list` DISABLE KEYS */;
/*!40000 ALTER TABLE `customize_list` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `email_campaigns`
--

DROP TABLE IF EXISTS `email_campaigns`;
CREATE TABLE `email_campaigns` (
  `email_id` smallint(5) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `from_addr` varchar(255) NOT NULL default '',
  `from_name` varchar(255) NOT NULL default '',
  `subject` varchar(255) NOT NULL default '',
  `reply_to` varchar(255) NOT NULL default '',
  `return_path` varchar(255) NOT NULL default '',
  `body` text,
  `html` text,
  `url` varchar(255) NOT NULL default '',
  `template_id` mediumint(8) unsigned NOT NULL default '0',
  `attach1_name` varchar(255) NOT NULL default '',
  `attach1` mediumblob,
  `attach2_name` varchar(255) NOT NULL default '',
  `attach2` mediumblob,
  `cron_d` date NOT NULL default '0000-00-00',
  `cron_t` time NOT NULL default '00:00:00',
  `cron_lock` tinyint(3) unsigned NOT NULL default '0',
  `use_uniq` tinyint(3) unsigned NOT NULL default '1',
  `uniqid` varchar(32) NOT NULL default '',
  `allow_profile` tinyint(3) unsigned NOT NULL default '1',
  `notify_email` varchar(255) NOT NULL default '',
  `monitor_reads` tinyint(3) unsigned NOT NULL default '1',
  `show_in_user_record` tinyint(3) unsigned NOT NULL default '1',
  `monitor_links` tinyint(3) unsigned NOT NULL default '1',
  `count_unique_clicks` tinyint(3) unsigned NOT NULL default '1',
  `profile_text` varchar(255) NOT NULL default 'To update your profile, click here %profile%',
  `unsub_text` varchar(255) NOT NULL default 'Click here to unsubscribe %unsub%',
  `share_email` tinyint(3) unsigned NOT NULL default '1',
  `share_text` varchar(255) NOT NULL default 'Click <a href=%share%>here</a> to share this email with a friend',
  `body_work` text,
  `html_work` text,
  `url_work` text,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_sent` datetime NOT NULL default '0000-00-00 00:00:00',
  `list_type` tinyint(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (`email_id`),
  KEY `i_campaign_template` (`template_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Email campaigns (simply stored emails)';

--
-- Dumping data for table `email_campaigns`
--

LOCK TABLES `email_campaigns` WRITE;
/*!40000 ALTER TABLE `email_campaigns` DISABLE KEYS */;
/*!40000 ALTER TABLE `email_campaigns` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `email_links`
--

DROP TABLE IF EXISTS `email_links`;
CREATE TABLE `email_links` (
  `link_id` mediumint(8) unsigned NOT NULL auto_increment,
  `campaign_id` mediumint(8) unsigned NOT NULL default '0',
  `body` text,
  `url` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`link_id`),
  KEY `i_email_links_campaign` (`campaign_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Links in email campaigns - subject of click monitoring';

--
-- Dumping data for table `email_links`
--

LOCK TABLES `email_links` WRITE;
/*!40000 ALTER TABLE `email_links` DISABLE KEYS */;
/*!40000 ALTER TABLE `email_links` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `email_reads`
--

DROP TABLE IF EXISTS `email_reads`;
CREATE TABLE `email_reads` (
  `read_id` mediumint(8) unsigned NOT NULL auto_increment,
  `stat_id` mediumint(8) unsigned NOT NULL default '0',
  `email` varchar(255) NOT NULL default '',
  `d` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`read_id`),
  KEY `email` (`email`,`stat_id`),
  KEY `i_email_reads_stat` (`stat_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stats on who and when read emails';

--
-- Dumping data for table `email_reads`
--

LOCK TABLES `email_reads` WRITE;
/*!40000 ALTER TABLE `email_reads` DISABLE KEYS */;
/*!40000 ALTER TABLE `email_reads` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `email_stats`
--

DROP TABLE IF EXISTS `email_stats`;
CREATE TABLE `email_stats` (
  `stats_id` mediumint(8) unsigned NOT NULL auto_increment,
  `email_id` mediumint(8) unsigned NOT NULL default '0',
  `category_ids` varchar(255) NOT NULL default '',
  `list` mediumtext,
  `rejected` mediumtext,
  `processed_list` mediumtext,
  `transient_errors` text,
  `sent` datetime NOT NULL default '0000-00-00 00:00:00',
  `uniq` varchar(16) NOT NULL default '',
  `started` datetime NOT NULL default '0000-00-00 00:00:00',
  `control` tinyint(3) unsigned NOT NULL default '0',
  `resend` mediumint(8) unsigned NOT NULL default '0',
  `last_update` bigint(20) default NULL,
  `friend_click` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`stats_id`),
  KEY `email_id` (`email_id`),
  KEY `category_ids` (`category_ids`),
  KEY `sent` (`sent`),
  KEY `last_update` (`last_update`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Statistics about email campaigns mailout';

--
-- Dumping data for table `email_stats`
--

LOCK TABLES `email_stats` WRITE;
/*!40000 ALTER TABLE `email_stats` DISABLE KEYS */;
/*!40000 ALTER TABLE `email_stats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `email_templates`
--

DROP TABLE IF EXISTS `email_templates`;
CREATE TABLE `email_templates` (
  `template_id` mediumint(8) unsigned NOT NULL auto_increment,
  `parent_id` mediumint(8) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `content` mediumblob,
  `fname` varchar(255) NOT NULL default '',
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`template_id`),
  KEY `i_email_template_parent` (`parent_id`)
) ENGINE=MyISAM AUTO_INCREMENT=31 DEFAULT CHARSET=latin1 COMMENT='Email templates';

--
-- Dumping data for table `email_templates`
--

LOCK TABLES `email_templates` WRITE;
/*!40000 ALTER TABLE `email_templates` DISABLE KEYS */;
INSERT INTO `email_templates` VALUES (1,0,'template1','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/style.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n\r\n<DIV align=center>\r\n<TABLE cellSpacing=0 cellPadding=0 width=601 border=0>\r\n<TBODY>\r\n<TR>\r\n        <TD width=1 bgColor=#333366 height=1266><IMG height=1 src=\"@@ROOT_URL@@/images/spacer.gif\" width=1></TD>\r\n<TD vAlign=top width=599>\r\n<TABLE cellSpacing=0 cellPadding=0 width=599 border=0>\r\n<TBODY>\r\n<TR>\r\n<TD width=256>\r\n<DIV align=center><FONT face=\"Arial, Helvetica, sans-serif\" size=3><STRONG>YOUR LOGO HERE</STRONG></FONT></DIV></TD>\r\n<TD><IMG height=86 src=\"@@ROOT_URL@@/images/banner_top_r1_c8.jpg\" width=343></TD></TR></TBODY></TABLE>\r\n<TABLE cellSpacing=0 cellPadding=0 width=599 border=0>\r\n<TBODY>\r\n<TR>\r\n<TD background=@@ROOT_URL@@/images/divider_line_top.gif><IMG height=1 src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=41></TD></TR>\r\n<TR>\r\n<TD height=24>\r\n<TABLE cellSpacing=0 cellPadding=0 width=599 border=0>\r\n<TBODY>\r\n<TR>\r\n<TD width=145 bgColor=#ffffff height=24>\r\n<DIV align=center><SPAN class=time><!-- #BeginDate format:Am1 -->September 22, 2004<!-- #EndDate --> </SPAN></DIV></TD>\r\n<TD width=7 height=24><IMG height=24 src=\"@@ROOT_URL@@/images/title_left.jpg\" width=7></TD>\r\n<TD class=maintitle bgColor=#333366>\r\n<TABLE cellSpacing=0 cellPadding=0 width=\"100%\" border=0>\r\n<TBODY>\r\n<TR>\r\n<TD width=5>&nbsp;</TD>\r\n<TD class=maintitle><FONT color=#ffffff><STRONG>NEWSLETTER TEMPLATE 1</STRONG></FONT></TD></TR></TBODY></TABLE></TD></TR></TBODY></TABLE></TD></TR>\r\n<TR>\r\n<TD background=@@ROOT_URL@@/images/divider_line_top.gif height=1><IMG height=1 src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=41></TD></TR></TBODY></TABLE>\r\n<TABLE cellSpacing=0 cellPadding=0 width=599 border=0>\r\n<TBODY>\r\n<TR>\r\n<TD vAlign=top bgColor=#fbfbfb height=425><BR>\r\n<TABLE class=border cellSpacing=0 cellPadding=0 width=577 align=center border=0>\r\n<TBODY>\r\n<TR>\r\n<TD vAlign=top width=575 height=382>\r\n<TABLE cellSpacing=5 cellPadding=0 width=\"100%\" align=left border=0>\r\n<TBODY>\r\n<TR>\r\n<TD class=bodytextCopy bgColor=#f0f0f0>Newsletter Sub-title</TD></TR>\r\n<TR>\r\n                                <TD class=bodytext vAlign=top height=1040> \r\n                                  <TABLE width=\"100%\" border=0>\r\n<TBODY>\r\n<TR>\r\n                                        <TD vAlign=top width=\"33%\" height=998> \r\n                                          <DIV align=center>\r\n<CENTER>\r\n<TABLE id=AutoNumber8 style=\"BORDER-COLLAPSE: collapse\" borderColor=#000000 height=1 cellSpacing=0 cellPadding=0 width=\"89%\" bgColor=#ffffff border=1>\r\n<TBODY>\r\n<TR>\r\n<TD style=\"BORDER-LEFT-WIDTH: 1px; BORDER-LEFT-COLOR: #000000; BORDER-RIGHT-WIDTH: 1px; BORDER-RIGHT-COLOR: #000000\" borderColor=#000000 align=middle width=\"100%\" bgColor=#0066ff height=1><B><FONT face=Arial color=#ffffff size=2>Main Menu</FONT></B></TD></TR>\r\n<TR>\r\n<TD style=\"BORDER-RIGHT: 1px solid; BORDER-TOP: 1px solid; BORDER-LEFT: 1px solid; BORDER-BOTTOM: medium none\" borderColor=#000000 width=\"100%\" bgColor=#ffffff height=1>\r\n<UL>\r\n<LI><FONT face=Arial size=2><A href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=1\">Main Article </A></FONT></LI>\r\n<LI><FONT face=Arial size=2><A href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=1\">Second Story</A></FONT></LI>\r\n<LI><FONT face=Arial size=2><A href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=1\">Third Story</A></FONT></LI>\r\n<LI><A href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=1\"><FONT face=Arial size=2>Fourth Story</FONT></A><FONT face=Arial size=2> </FONT></LI></UL></TD></TR></TBODY></TABLE></CENTER></DIV>\r\n<P style=\"MARGIN-TOP: 0px; MARGIN-BOTTOM: 0px\" align=center> \r\n<DIV align=center>\r\n<CENTER>\r\n<TABLE id=AutoNumber12 style=\"BORDER-COLLAPSE: collapse\" borderColor=#111111 height=1 cellSpacing=0 cellPadding=0 width=\"90%\" border=1>\r\n<TBODY>\r\n<TR>\r\n<TD style=\"BORDER-RIGHT: medium none; BORDER-TOP: medium none; BORDER-LEFT: medium none; BORDER-BOTTOM: medium none\" width=\"100%\" bgColor=#0066ff height=1>\r\n<P align=center><B><FONT face=Arial color=#ffffff size=2>Spotlight Article </FONT></B></P></TD></TR>\r\n<TR>\r\n<TD style=\"BORDER-RIGHT: medium none; BORDER-TOP: medium none; BORDER-LEFT: medium none; BORDER-BOTTOM: medium none\" vAlign=top width=\"100%\" bgColor=#ffffff height=18>\r\n<P style=\"MARGIN-TOP: 9px; MARGIN-BOTTOM: 9px; MARGIN-LEFT: 5px\"><IMG height=150 src=\"@@ROOT_URL@@/images/image2.jpg\" width=150> \r\n<P style=\"MARGIN-TOP: 9px; MARGIN-BOTTOM: 9px; MARGIN-LEFT: 5px\"> \r\n<P style=\"MARGIN-TOP: 9px; MARGIN-BOTTOM: 9px; MARGIN-LEFT: 5px\"><FONT face=\"Arial, Helvetica, sans-serif\" size=2>This is the intro text for this article. This is the intro text for this article.This is the intro text for this article.This is the intro text for this article.</FONT><BR><A href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=1\"><FONT face=\"Arial, Helvetica, sans-serif\" size=2>Find out more.... </FONT></A>\r\n<P style=\"MARGIN-TOP: 9px; MARGIN-BOTTOM: 9px; MARGIN-LEFT: 5px\"><FONT face=\"Arial, Helvetica, sans-serif\"><STRONG>More Information...</STRONG></FONT> \r\n<UL>\r\n<LI>yourlink.com</LI>\r\n<LI>yourlink.com</LI></UL></TD></TR></TBODY></TABLE></CENTER></DIV></TD>\r\n                                        <TD vAlign=top width=\"67%\"> <table width=\"100%\" border=\"0\">\r\n                                            <tr>\r\n                                              <td height=\"271\"> \r\n                                                <TABLE class=border cellSpacing=0 cellPadding=0 width=393 align=left border=0>\r\n                                                  <TBODY>\r\n                                                    <TR> \r\n                                                      <TD vAlign=top width=393 height=207> \r\n                                                        <TABLE cellSpacing=5 cellPadding=0 width=392 align=left border=0>\r\n                                                          <TBODY>\r\n                                                            <TR> \r\n                                                              <TD class=bodytextCopy width=382 bgColor=#f0f0f0><FONT face=\"Verdana, Arial, Helvetica, sans-serif\" size=2><STRONG>Main \r\n                                                                Article</STRONG></FONT></TD>\r\n                                                            </TR>\r\n                                                            <TR> \r\n                                                              <TD class=bodytext vAlign=top height=174> \r\n                                                                <P><FONT face=\"Verdana, Arial, Helvetica, sans-serif\" size=2>This \r\n                                                                  is the text \r\n                                                                  for main article. \r\n                                                                  This is the \r\n                                                                  text for main \r\n                                                                  article. This \r\n                                                                  is the text \r\n                                                                  for main article. \r\n                                                                  This is the \r\n                                                                  text for main \r\n                                                                  article. This \r\n                                                                  is the text \r\n                                                                  for main article. \r\n                                                                  This is the \r\n                                                                  text for main \r\n                                                                  article. This \r\n                                                                  is the text \r\n                                                                  for main article. \r\n                                                                  This is the \r\n                                                                  text for main \r\n                                                                  article. This \r\n                                                                  is the text \r\n                                                                  for main article. \r\n                                                                  This is the \r\n                                                                  text for main \r\n                                                                  article. This \r\n                                                                  is the text \r\n                                                                  for main article. \r\n                                                                  This is the \r\n                                                                  text for main \r\n                                                                  article. This \r\n                                                                  is the text \r\n                                                                  for main article. \r\n                                                                  This is the \r\n                                                                  text for main \r\n                                                                  article. This \r\n                                                                  is the text \r\n                                                                  for main article. \r\n                                                                  This is the \r\n                                                                  text for main \r\n                                                                  article. </FONT></P></TD>\r\n                                                            </TR>\r\n                                                          </TBODY>\r\n                                                        </TABLE>\r\n                                                        <BR> <BR> <BR> <BR> <BR></TD>\r\n                                                    </TR>\r\n                                                    <TR> \r\n                                                      <TD bgColor=#cccccc height=15> \r\n                                                        <DIV align=right><A href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=1\"><IMG id=Image121 height=15 alt=\"Read More\" src=\"@@ROOT_URL@@/images/tab_readmore.gif\" width=95 border=0 name=Image121111></A></DIV></TD>\r\n                                                    </TR>\r\n                                                  </TBODY>\r\n                                                </TABLE>\r\n                                                <P><BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                </P>\r\n</td>\r\n                                            </tr>\r\n                                            <tr>\r\n                                              <td><TABLE class=border cellSpacing=0 cellPadding=0 width=393 align=left border=0>\r\n                                                  <TBODY>\r\n                                                    <TR> \r\n                                                      <TD vAlign=top width=393 height=207> \r\n                                                        <TABLE cellSpacing=5 cellPadding=0 width=392 align=left border=0>\r\n                                                          <TBODY>\r\n                                                            <TR> \r\n                                                              <TD class=bodytextCopy width=382 bgColor=#f0f0f0><FONT face=\"Verdana, Arial, Helvetica, sans-serif\" size=2><STRONG>Second \r\n                                                                Newsletter Story</STRONG></FONT></TD>\r\n                                                            </TR>\r\n                                                            <TR> \r\n                                                              <TD class=bodytext vAlign=top height=174> \r\n                                                                <P><FONT face=\"Verdana, Arial, Helvetica, sans-serif\" size=2>It \r\n                                                                  is currently \r\n                                                                  easier than \r\n                                                                  ever to sell \r\n                                                                  products online. \r\n                                                                  Through the \r\n                                                                  use of integrated \r\n                                                                  solutions that \r\n                                                                  provide the \r\n                                                                  traditional \r\n                                                                  shopping cart \r\n                                                                  functionality \r\n                                                                  and a seamless \r\n                                                                  integration \r\n                                                                  into a payment \r\n                                                                  gateway <BR>\r\n                                                                  It is currently \r\n                                                                  easier than \r\n                                                                  ever to sell \r\n                                                                  products online. \r\n                                                                  Through the \r\n                                                                  use of integrated \r\n                                                                  solutions that \r\n                                                                  provide the \r\n                                                                  traditional \r\n                                                                  shopping cart \r\n                                                                  functionality \r\n                                                                  and a seamless \r\n                                                                  integration \r\n                                                                  into a payment \r\n                                                                  gateway </FONT></P></TD>\r\n                                                            </TR>\r\n                                                          </TBODY>\r\n                                                        </TABLE>\r\n                                                        <BR> <BR> <BR> <BR> <BR></TD>\r\n                                                    </TR>\r\n                                                    <TR> \r\n                                                      <TD bgColor=#cccccc height=15> \r\n                                                        <DIV align=right><A href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=1\"><IMG id=Image121 height=15 alt=\"Read More\" src=\"@@ROOT_URL@@/images/tab_readmore.gif\" width=95 border=0 name=Image12111></A></DIV></TD>\r\n                                                    </TR>\r\n                                                  </TBODY>\r\n                                                </TABLE>\r\n                                                <P><BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                </P>\r\n</td>\r\n                                            </tr>\r\n                                            <tr>\r\n                                              <td height=\"267\"> \r\n                                                <TABLE class=border cellSpacing=0 cellPadding=0 width=393 align=left border=0>\r\n                                                  <TBODY>\r\n                                                    <TR> \r\n                                                      <TD vAlign=top width=393 height=207> \r\n                                                        <TABLE cellSpacing=5 cellPadding=0 width=392 align=left border=0>\r\n                                                          <TBODY>\r\n                                                            <TR> \r\n                                                              <TD class=bodytextCopy width=382 bgColor=#f0f0f0><FONT face=\"Verdana, Arial, Helvetica, sans-serif\" size=2><STRONG>Third \r\n                                                                Newsletter Story</STRONG></FONT></TD>\r\n                                                            </TR>\r\n                                                            <TR> \r\n                                                              <TD class=bodytext vAlign=top height=174> \r\n                                                                <P><FONT face=\"Verdana, Arial, Helvetica, sans-serif\" size=2>It \r\n                                                                  is currently \r\n                                                                  easier than \r\n                                                                  ever to sell \r\n                                                                  products online. \r\n                                                                  Through the \r\n                                                                  use of integrated \r\n                                                                  solutions that \r\n                                                                  provide the \r\n                                                                  traditional \r\n                                                                  shopping cart \r\n                                                                  functionality \r\n                                                                  and a seamless \r\n                                                                  integration \r\n                                                                  into a payment \r\n                                                                  gateway <BR>\r\n                                                                  It is currently \r\n                                                                  easier than \r\n                                                                  ever to sell \r\n                                                                  products online. \r\n                                                                  Through the \r\n                                                                  use of integrated \r\n                                                                  solutions that \r\n                                                                  provide the \r\n                                                                  traditional \r\n                                                                  shopping cart \r\n                                                                  functionality \r\n                                                                  and a seamless \r\n                                                                  integration \r\n                                                                  into a payment \r\n                                                                  gateway </FONT></P></TD>\r\n                                                            </TR>\r\n                                                          </TBODY>\r\n                                                        </TABLE>\r\n                                                        <BR> <BR> <BR> <BR> <BR></TD>\r\n                                                    </TR>\r\n                                                    <TR> \r\n                                                      <TD bgColor=#cccccc height=15> \r\n                                                        <DIV align=right><A href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=1\"><IMG id=Image121 height=15 alt=\"Read More\" src=\"@@ROOT_URL@@/images/tab_readmore.gif\" width=95 border=0 name=Image121111></A></DIV></TD>\r\n                                                    </TR>\r\n                                                  </TBODY>\r\n                                                </TABLE>\r\n                                                <P><BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                </P>\r\n</td>\r\n                                            </tr>\r\n                                            <tr>\r\n                                              <td height=\"44\"><TABLE class=border cellSpacing=0 cellPadding=0 width=393 align=left border=0>\r\n                                                  <TBODY>\r\n                                                    <TR> \r\n                                                      <TD vAlign=top width=393 height=207> \r\n                                                        <TABLE cellSpacing=5 cellPadding=0 width=392 align=left border=0>\r\n                                                          <TBODY>\r\n                                                            <TR> \r\n                                                              <TD class=bodytextCopy width=382 bgColor=#f0f0f0><FONT face=\"Verdana, Arial, Helvetica, sans-serif\" size=2><STRONG>Fourth \r\n                                                                Newsletter Story</STRONG></FONT></TD>\r\n                                                            </TR>\r\n                                                            <TR> \r\n                                                              <TD class=bodytext vAlign=top height=174> \r\n                                                                <P><FONT face=\"Verdana, Arial, Helvetica, sans-serif\" size=2>It \r\n                                                                  is currently \r\n                                                                  easier than \r\n                                                                  ever to sell \r\n                                                                  products online. \r\n                                                                  Through the \r\n                                                                  use of integrated \r\n                                                                  solutions that \r\n                                                                  provide the \r\n                                                                  traditional \r\n                                                                  shopping cart \r\n                                                                  functionality \r\n                                                                  and a seamless \r\n                                                                  integration \r\n                                                                  into a payment \r\n                                                                  gateway <BR>\r\n                                                                  It is currently \r\n                                                                  easier than \r\n                                                                  ever to sell \r\n                                                                  products online. \r\n                                                                  Through the \r\n                                                                  use of integrated \r\n                                                                  solutions that \r\n                                                                  provide the \r\n                                                                  traditional \r\n                                                                  shopping cart \r\n                                                                  functionality \r\n                                                                  and a seamless \r\n                                                                  integration \r\n                                                                  into a payment \r\n                                                                  gateway </FONT></P></TD>\r\n                                                            </TR>\r\n                                                          </TBODY>\r\n                                                        </TABLE>\r\n                                                        <BR> <BR> <BR> <BR> <BR></TD>\r\n                                                    </TR>\r\n                                                    <TR> \r\n                                                      <TD bgColor=#cccccc height=15> \r\n                                                        <DIV align=right><A href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=1\"><IMG id=Image121 height=15 alt=\"Read More\" src=\"@@ROOT_URL@@/images/tab_readmore.gif\" width=95 border=0 name=Image1211111></A></DIV></TD>\r\n                                                    </TR>\r\n                                                  </TBODY>\r\n                                                </TABLE>\r\n                                                <P><BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                  <BR>\r\n                                                </P>\r\n</td>\r\n                                            </tr>\r\n                                          </table>\r\n                                          \r\n                                        </TD>\r\n                                      </TR></TBODY></TABLE>\r\n                                </TD>\r\n                              </TR></TBODY></TABLE></TD></TR>\r\n<TR>\r\n<TD bgColor=#cccccc height=19>\r\n<DIV align=right></DIV></TD></TR></TBODY></TABLE></TD></TR></TBODY></TABLE>\r\n<TABLE cellSpacing=0 cellPadding=0 width=599 border=0>\r\n<TBODY>\r\n<TR>\r\n<TD background=@@ROOT_URL@@/images/divider_line_purple.gif><IMG height=1 src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=30></TD></TR>\r\n<TR>\r\n<TD bgColor=#f0f0f0>\r\n<DIV align=right>\r\n<TABLE cellSpacing=0 cellPadding=0 width=599 border=0>\r\n<TBODY>\r\n<TR>\r\n<TD width=343 height=19>&nbsp;</TD>\r\n<TD width=89>\r\n<DIV class=bottomlinks align=center></DIV></TD>\r\n<TD width=87>\r\n<DIV class=bottomlinks align=center></DIV></TD>\r\n<TD width=80>\r\n<DIV class=bottomlinks align=center></DIV></TD></TR></TBODY></TABLE></DIV></TD></TR>\r\n<TR>\r\n<TD background=@@ROOT_URL@@/images/divider_line_purple.gif><IMG height=1 src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=30></TD></TR></TBODY></TABLE>\r\n<TABLE cellSpacing=0 cellPadding=0 width=599 border=0>\r\n<TBODY>\r\n<TR>\r\n                <TD vAlign=top bgColor=#ffffff height=19> \r\n                  <DIV class=copyright align=right></DIV></TD></TR>\r\n<TR>\r\n<TD background=@@ROOT_URL@@/images/divider_line_purple.gif height=2><IMG height=1 src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=30></TD></TR></TBODY></TABLE></TD>\r\n<TD width=10 bgColor=#333366><IMG height=1 src=\"@@ROOT_URL@@/images/spacer.gif\" width=1></TD></TR></TBODY></TABLE>\r\n</DIV>\r\n','temp1.htm','0000-00-00 00:00:00'),(2,1,'template 1 - subpage 1','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"793\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td width=\"256\"><div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><strong>YOUR \r\n                LOGO HERE</strong></font></div></td>\r\n            <td><img src=\"@@ROOT_URL@@/images/banner_top_r1_c8.jpg\" width=\"343\" height=\"86\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 1</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"425\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"382\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"347\" valign=\"top\" class=\"bodytext\"> <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"33%\" height=\"745\" valign=\"top\"> \r\n                                <div align=\"center\">\r\n<center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#000000\" width=\"89%\" id=\"AutoNumber8\" height=\"1\" bgcolor=\"#FFFFFF\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#6600CC\" height=\"1\" bordercolor=\"#000000\" align=\"center\" style=\"border-left-color: #000000; border-left-width: 1; border-right-color: #000000; border-right-width: 1\"> \r\n                                          <b><font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                          Menu</font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#FFFFFF\" height=\"1\" bordercolor=\"#000000\" style=\"border-left-style: solid; border-left-width: 1; border-right-style: solid; border-right-width: 1; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\"> \r\n                                          <ul>\r\n                                            <li> <font face=\"Arial\" size=\"2\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=1\">Main \r\n                                              Article </a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=1\">Second \r\n                                              Story</a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=1\">Third \r\n                                              Story</a></font></li>\r\n                                            <li><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=1\"><font size=\"2\" face=\"Arial\">Fourth \r\n                                              Story</font></a><font size=\"2\" face=\"Arial\"> \r\n                                              </font></li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div>\r\n                                <p align=\"center\" style=\"margin-top: 0; margin-bottom: 0\">&nbsp; \r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"90%\" id=\"AutoNumber12\" height=\"1\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#6600CC\" height=\"1\"> \r\n                                          <p align=\"center\"><b> <font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                            Article </font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#FFFFFF\" height=\"18\" valign=\"top\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><img src=\"@@ROOT_URL@@/images/image-small.gif\" width=\"150\" height=\"150\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\">&nbsp; \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">This \r\n                                            is the intro text for this article. \r\n                                            This is the intro text for this article.This \r\n                                            is the intro text for this article.This \r\n                                            is the intro text for this article.</font><br>\r\n                                            <a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=1\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">Find \r\n                                            out more.... </font></a> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font face=\"Arial, Helvetica, sans-serif\"><strong>More \r\n                                            Information...</strong></font> \r\n                                          <ul>\r\n                                            <li>yourlink.com</li>\r\n                                            <li>yourlink.com</li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"67%\" valign=\"top\"> <p style=\"margin-left: 4; margin-right: 4; margin-top: 9; margin-bottom: 4\" align=\"left\">&nbsp; \r\n                                </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Main \r\n                                            Article </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n</td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n</div>\r\n</body>\r\n</html>\r\n','temp1-subpage1.htm','0000-00-00 00:00:00'),(3,1,'template 1 - subpage 2','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"793\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td width=\"256\"><div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><strong>YOUR \r\n                LOGO HERE</strong></font></div></td>\r\n            <td><img src=\"@@ROOT_URL@@/images/banner_top_r1_c8.jpg\" width=\"343\" height=\"86\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 1</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"425\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"382\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"347\" valign=\"top\" class=\"bodytext\"> <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"33%\" height=\"745\" valign=\"top\"> \r\n                                <div align=\"center\">\r\n<center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#000000\" width=\"89%\" id=\"AutoNumber8\" height=\"1\" bgcolor=\"#FFFFFF\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#6600CC\" height=\"1\" bordercolor=\"#000000\" align=\"center\" style=\"border-left-color: #000000; border-left-width: 1; border-right-color: #000000; border-right-width: 1\"> \r\n                                          <b><font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                          Menu</font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#FFFFFF\" height=\"1\" bordercolor=\"#000000\" style=\"border-left-style: solid; border-left-width: 1; border-right-style: solid; border-right-width: 1; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\"> \r\n                                          <ul>\r\n                                            <li> <font face=\"Arial\" size=\"2\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=1\">Main \r\n                                              Article </a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=1\">Second \r\n                                              Story</a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=1\">Third \r\n                                              Story</a></font></li>\r\n                                            <li><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=1\"><font size=\"2\" face=\"Arial\">Fourth \r\n                                              Story</font></a><font size=\"2\" face=\"Arial\"> \r\n                                              </font></li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div>\r\n                                <p align=\"center\" style=\"margin-top: 0; margin-bottom: 0\">&nbsp; \r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"90%\" id=\"AutoNumber12\" height=\"1\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#6600CC\" height=\"1\"> \r\n                                          <p align=\"center\"><b> <font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Second \r\n                                            Story </font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#FFFFFF\" height=\"18\" valign=\"top\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><img src=\"@@ROOT_URL@@/images/image-small.gif\" width=\"150\" height=\"150\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\">&nbsp; \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">This \r\n                                            is the intro text for this article. \r\n                                            This is the intro text for this article.This \r\n                                            is the intro text for this article.This \r\n                                            is the intro text for this article.</font><br>\r\n                                            <a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=1\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">Find \r\n                                            out more.... </font></a> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font face=\"Arial, Helvetica, sans-serif\"><strong>More \r\n                                            Information...</strong></font> \r\n                                          <ul>\r\n                                            <li>yourlink.com</li>\r\n                                            <li>yourlink.com</li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"67%\" valign=\"top\"> <p style=\"margin-left: 4; margin-right: 4; margin-top: 9; margin-bottom: 4\" align=\"left\">&nbsp; \r\n                                </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Second \r\n                                            Story </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n</td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n</td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n</div>\r\n</body>\r\n</html>\r\n','temp1-subpage2.htm','0000-00-00 00:00:00'),(4,1,'template 1 - subpage 3','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"793\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td width=\"256\"><div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><strong>YOUR \r\n                LOGO HERE</strong></font></div></td>\r\n            <td><img src=\"@@ROOT_URL@@/images/banner_top_r1_c8.jpg\" width=\"343\" height=\"86\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 1</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"425\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"382\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"347\" valign=\"top\" class=\"bodytext\"> <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"33%\" height=\"745\" valign=\"top\"> \r\n                                <div align=\"center\">\r\n<center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#000000\" width=\"89%\" id=\"AutoNumber8\" height=\"1\" bgcolor=\"#FFFFFF\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#6600CC\" height=\"1\" bordercolor=\"#000000\" align=\"center\" style=\"border-left-color: #000000; border-left-width: 1; border-right-color: #000000; border-right-width: 1\"> \r\n                                          <b><font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                          Menu</font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#FFFFFF\" height=\"1\" bordercolor=\"#000000\" style=\"border-left-style: solid; border-left-width: 1; border-right-style: solid; border-right-width: 1; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\"> \r\n                                          <ul>\r\n                                            <li> <font face=\"Arial\" size=\"2\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=1\">Main \r\n                                              Article </a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=1\">Second \r\n                                              Story</a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=1\">Third \r\n                                              Story</a></font></li>\r\n                                            <li><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=1\"><font size=\"2\" face=\"Arial\">Fourth \r\n                                              Story</font></a><font size=\"2\" face=\"Arial\"> \r\n                                              </font></li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div>\r\n                                <p align=\"center\" style=\"margin-top: 0; margin-bottom: 0\">&nbsp; \r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"90%\" id=\"AutoNumber12\" height=\"1\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#6600CC\" height=\"1\"> \r\n                                          <p align=\"center\"><b> <font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Third \r\n                                            Story </font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#FFFFFF\" height=\"18\" valign=\"top\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><img src=\"@@ROOT_URL@@/images/image-small.gif\" width=\"150\" height=\"150\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\">&nbsp; \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">This \r\n                                            is the intro text for this article. \r\n                                            This is the intro text for this article.This \r\n                                            is the intro text for this article.This \r\n                                            is the intro text for this article.</font><br>\r\n                                            <a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=1\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">Find \r\n                                            out more.... </font></a> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font face=\"Arial, Helvetica, sans-serif\"><strong>More \r\n                                            Information...</strong></font> \r\n                                          <ul>\r\n                                            <li>yourlink.com</li>\r\n                                            <li>yourlink.com</li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"67%\" valign=\"top\"> <p style=\"margin-left: 4; margin-right: 4; margin-top: 9; margin-bottom: 4\" align=\"left\">&nbsp; \r\n                                </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Third \r\n                                            Story </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n</td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n</div>\r\n</body>\r\n</html>\r\n','temp1-subpage3.htm','0000-00-00 00:00:00'),(5,1,'template 1 - subpage 4','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"793\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td width=\"256\"><div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><strong>YOUR \r\n                LOGO HERE</strong></font></div></td>\r\n            <td><img src=\"@@ROOT_URL@@/images/banner_top_r1_c8.jpg\" width=\"343\" height=\"86\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 1</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"425\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"382\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"347\" valign=\"top\" class=\"bodytext\"> <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"33%\" height=\"745\" valign=\"top\"> \r\n                                <div align=\"center\">\r\n<center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#000000\" width=\"89%\" id=\"AutoNumber8\" height=\"1\" bgcolor=\"#FFFFFF\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#6600CC\" height=\"1\" bordercolor=\"#000000\" align=\"center\" style=\"border-left-color: #000000; border-left-width: 1; border-right-color: #000000; border-right-width: 1\"> \r\n                                          <b><font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                          Menu</font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#FFFFFF\" height=\"1\" bordercolor=\"#000000\" style=\"border-left-style: solid; border-left-width: 1; border-right-style: solid; border-right-width: 1; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\"> \r\n                                          <ul>\r\n                                            <li> <font face=\"Arial\" size=\"2\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=1\">Main \r\n                                              Article </a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=1\">Second \r\n                                              Story</a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=1\">Third \r\n                                              Story</a></font></li>\r\n                                            <li><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=1\"><font size=\"2\" face=\"Arial\">Fourth \r\n                                              Story</font></a><font size=\"2\" face=\"Arial\"> \r\n                                              </font></li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div>\r\n                                <p align=\"center\" style=\"margin-top: 0; margin-bottom: 0\">&nbsp; \r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"90%\" id=\"AutoNumber12\" height=\"1\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#6600CC\" height=\"1\"> \r\n                                          <p align=\"center\"><b> <font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Fourth \r\n                                            Story </font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#FFFFFF\" height=\"18\" valign=\"top\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><img src=\"@@ROOT_URL@@/images/image-small.gif\" width=\"150\" height=\"150\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\">&nbsp; \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">This \r\n                                            is the intro text for this article. \r\n                                            This is the intro text for this article.This \r\n                                            is the intro text for this article.This \r\n                                            is the intro text for this article.</font><br>\r\n                                            <a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=1\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">Find \r\n                                            out more.... </font></a> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font face=\"Arial, Helvetica, sans-serif\"><strong>More \r\n                                            Information...</strong></font> \r\n                                          <ul>\r\n                                            <li>yourlink.com</li>\r\n                                            <li>yourlink.com</li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"67%\" valign=\"top\"> <p style=\"margin-left: 4; margin-right: 4; margin-top: 9; margin-bottom: 4\" align=\"left\">&nbsp; \r\n                                </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Fourth \r\n                                            Story </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n</td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n</div>\r\n</body>\r\n</html>\r\n','temp1-subpage4.htm','0000-00-00 00:00:00'),(6,0,'template2','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title></title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"793\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td> <div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><strong><br>\r\n                YOUR SLOGAN HERE<br>\r\n                <br>\r\n                <br>\r\n                </strong></font></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 1</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"425\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"382\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"878\" valign=\"top\" class=\"bodytext\"> \r\n                          <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"33%\" height=\"745\" valign=\"top\"> \r\n                                <div align=\"center\">\r\n<center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#000000\" width=\"89%\" id=\"AutoNumber8\" height=\"1\" bgcolor=\"#FFFFFF\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#0066FF\" height=\"1\" bordercolor=\"#000000\" align=\"center\" style=\"border-left-color: #000000; border-left-width: 1; border-right-color: #000000; border-right-width: 1\"> \r\n                                          <b><font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                          Menu</font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#FFFFFF\" height=\"1\" bordercolor=\"#000000\" style=\"border-left-style: solid; border-left-width: 1; border-right-style: solid; border-right-width: 1; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\"> \r\n                                          <ul>\r\n                                            <li> <font face=\"Arial\" size=\"2\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=6\">Main \r\n                                              Article </a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=6\">Second \r\n                                              Story</a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=6\">Third \r\n                                              Story</a></font></li>\r\n                                            <li><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=6\"><font size=\"2\" face=\"Arial\">Fourth \r\n                                              Story</font></a><font size=\"2\" face=\"Arial\"> \r\n                                              </font></li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div>\r\n                                <p align=\"center\" style=\"margin-top: 0; margin-bottom: 0\">&nbsp; \r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"90%\" id=\"AutoNumber12\" height=\"1\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#0066FF\" height=\"1\"> \r\n                                          <p align=\"center\"><b> <font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Spotlight \r\n                                            Article </font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#FFFFFF\" height=\"18\" valign=\"top\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><img src=\"@@ROOT_URL@@/images/image2.jpg\" width=\"150\" height=\"150\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\">&nbsp; \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">This \r\n                                            is the intro text for this article. \r\n                                            This is the intro text for this article.This \r\n                                            is the intro text for this article.This \r\n                                            is the intro text for this article.</font><br>\r\n                                            <a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=6\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">Find \r\n                                            out more.... </font></a> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font face=\"Arial, Helvetica, sans-serif\"><strong>More \r\n                                            Information...</strong></font> \r\n                                          <ul>\r\n                                            <li>yourlink.com</li>\r\n                                            <li>yourlink.com</li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"67%\" valign=\"top\">\r\n			        <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Main \r\n                                            Article</strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=6\"><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image121111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Second \r\n                                            Newsletter Story</strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=6\"><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image12111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Third \r\n                                            Newsletter Story</strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=6\" ><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image121111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Fourth \r\n                                            Newsletter Story</strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=6\"><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image1211111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p></p>\r\n                                <p>&nbsp; </p>\r\n</td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">\r\n    <tr>\r\n      <td class=\"copyright\">&nbsp;</td>\r\n    </tr>\r\n  </table>\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp2.htm','0000-00-00 00:00:00'),(7,6,'template 2 - subpage 1','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"793\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td width=\"256\"><div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><strong>YOUR \r\n                LOGO HERE</strong></font></div></td>\r\n            <td><img src=\"@@ROOT_URL@@/images/banner_top_r1_c8.jpg\" width=\"343\" height=\"86\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 1</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"425\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"382\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"347\" valign=\"top\" class=\"bodytext\"> <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"33%\" height=\"745\" valign=\"top\"> \r\n                                <div align=\"center\">\r\n<center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#000000\" width=\"89%\" id=\"AutoNumber8\" height=\"1\" bgcolor=\"#FFFFFF\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#6600CC\" height=\"1\" bordercolor=\"#000000\" align=\"center\" style=\"border-left-color: #000000; border-left-width: 1; border-right-color: #000000; border-right-width: 1\"> \r\n                                          <b><font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                          Menu</font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#FFFFFF\" height=\"1\" bordercolor=\"#000000\" style=\"border-left-style: solid; border-left-width: 1; border-right-style: solid; border-right-width: 1; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\"> \r\n                                          <ul>\r\n                                            <li> <font face=\"Arial\" size=\"2\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=6\">Main \r\n                                              Article </a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=6\">Second \r\n                                              Story</a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=6\">Third \r\n                                              Story</a></font></li>\r\n                                            <li><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=6\"><font size=\"2\" face=\"Arial\">Fourth \r\n                                              Story</font></a><font size=\"2\" face=\"Arial\"> \r\n                                              </font></li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div>\r\n                                <p align=\"center\" style=\"margin-top: 0; margin-bottom: 0\">&nbsp; \r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"90%\" id=\"AutoNumber12\" height=\"1\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#6600CC\" height=\"1\"> \r\n                                          <p align=\"center\"><b> <font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                            Article </font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#FFFFFF\" height=\"18\" valign=\"top\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><img src=\"@@ROOT_URL@@/images/image-small.gif\" width=\"150\" height=\"150\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\">&nbsp; \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">This \r\n                                            is the intro text for this article. \r\n                                            This is the intro text for this article.This \r\n                                            is the intro text for this article.This \r\n                                            is the intro text for this article.</font><br>\r\n                                            <a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=6\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">Find \r\n                                            out more.... </font></a> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font face=\"Arial, Helvetica, sans-serif\"><strong>More \r\n                                            Information...</strong></font> \r\n                                          <ul>\r\n                                            <li>yourlink.com</li>\r\n                                            <li>yourlink.com</li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"67%\" valign=\"top\"> <p style=\"margin-left: 4; margin-right: 4; margin-top: 9; margin-bottom: 4\" align=\"left\">&nbsp; \r\n                                </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Main \r\n                                            Article </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n</td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n</div>\r\n</body>\r\n</html>\r\n','temp1-subpage1.htm','0000-00-00 00:00:00'),(8,6,'template 2 - subpage 2','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"793\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td width=\"256\"><div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><strong>YOUR \r\n                LOGO HERE</strong></font></div></td>\r\n            <td><img src=\"@@ROOT_URL@@/images/banner_top_r1_c8.jpg\" width=\"343\" height=\"86\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 1</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"425\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"382\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"347\" valign=\"top\" class=\"bodytext\"> <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"33%\" height=\"745\" valign=\"top\"> \r\n                                <div align=\"center\">\r\n<center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#000000\" width=\"89%\" id=\"AutoNumber8\" height=\"1\" bgcolor=\"#FFFFFF\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#6600CC\" height=\"1\" bordercolor=\"#000000\" align=\"center\" style=\"border-left-color: #000000; border-left-width: 1; border-right-color: #000000; border-right-width: 1\"> \r\n                                          <b><font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                          Menu</font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#FFFFFF\" height=\"1\" bordercolor=\"#000000\" style=\"border-left-style: solid; border-left-width: 1; border-right-style: solid; border-right-width: 1; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\"> \r\n                                          <ul>\r\n                                            <li> <font face=\"Arial\" size=\"2\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=6\">Main \r\n                                              Article </a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=6\">Second \r\n                                              Story</a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=6\">Third \r\n                                              Story</a></font></li>\r\n                                            <li><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=6\"><font size=\"2\" face=\"Arial\">Fourth \r\n                                              Story</font></a><font size=\"2\" face=\"Arial\"> \r\n                                              </font></li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div>\r\n                                <p align=\"center\" style=\"margin-top: 0; margin-bottom: 0\">&nbsp; \r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"90%\" id=\"AutoNumber12\" height=\"1\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#6600CC\" height=\"1\"> \r\n                                          <p align=\"center\"><b> <font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Second \r\n                                            Story </font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#FFFFFF\" height=\"18\" valign=\"top\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><img src=\"@@ROOT_URL@@/images/image-small.gif\" width=\"150\" height=\"150\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\">&nbsp; \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">This \r\n                                            is the intro text for this article. \r\n                                            This is the intro text for this article.This \r\n                                            is the intro text for this article.This \r\n                                            is the intro text for this article.</font><br>\r\n                                            <a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=6\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">Find \r\n                                            out more.... </font></a> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font face=\"Arial, Helvetica, sans-serif\"><strong>More \r\n                                            Information...</strong></font> \r\n                                          <ul>\r\n                                            <li>yourlink.com</li>\r\n                                            <li>yourlink.com</li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"67%\" valign=\"top\"> <p style=\"margin-left: 4; margin-right: 4; margin-top: 9; margin-bottom: 4\" align=\"left\">&nbsp; \r\n                                </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Second \r\n                                            Story </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n</td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n</td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n</div>\r\n</body>\r\n</html>\r\n','temp1-subpage2.htm','0000-00-00 00:00:00'),(9,6,'template 2 - subpage 3','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"793\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td width=\"256\"><div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><strong>YOUR \r\n                LOGO HERE</strong></font></div></td>\r\n            <td><img src=\"@@ROOT_URL@@/images/banner_top_r1_c8.jpg\" width=\"343\" height=\"86\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 1</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"425\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"382\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"347\" valign=\"top\" class=\"bodytext\"> <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"33%\" height=\"745\" valign=\"top\"> \r\n                                <div align=\"center\">\r\n<center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#000000\" width=\"89%\" id=\"AutoNumber8\" height=\"1\" bgcolor=\"#FFFFFF\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#6600CC\" height=\"1\" bordercolor=\"#000000\" align=\"center\" style=\"border-left-color: #000000; border-left-width: 1; border-right-color: #000000; border-right-width: 1\"> \r\n                                          <b><font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                          Menu</font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#FFFFFF\" height=\"1\" bordercolor=\"#000000\" style=\"border-left-style: solid; border-left-width: 1; border-right-style: solid; border-right-width: 1; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\"> \r\n                                          <ul>\r\n                                            <li> <font face=\"Arial\" size=\"2\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=6\">Main \r\n                                              Article </a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=6\">Second \r\n                                              Story</a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=6\">Third \r\n                                              Story</a></font></li>\r\n                                            <li><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=6\"><font size=\"2\" face=\"Arial\">Fourth \r\n                                              Story</font></a><font size=\"2\" face=\"Arial\"> \r\n                                              </font></li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div>\r\n                                <p align=\"center\" style=\"margin-top: 0; margin-bottom: 0\">&nbsp; \r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"90%\" id=\"AutoNumber12\" height=\"1\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#6600CC\" height=\"1\"> \r\n                                          <p align=\"center\"><b> <font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Third \r\n                                            Story </font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#FFFFFF\" height=\"18\" valign=\"top\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><img src=\"@@ROOT_URL@@/images/image-small.gif\" width=\"150\" height=\"150\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\">&nbsp; \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">This \r\n                                            is the intro text for this article. \r\n                                            This is the intro text for this article.This \r\n                                            is the intro text for this article.This \r\n                                            is the intro text for this article.</font><br>\r\n                                            <a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=6\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">Find \r\n                                            out more.... </font></a> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font face=\"Arial, Helvetica, sans-serif\"><strong>More \r\n                                            Information...</strong></font> \r\n                                          <ul>\r\n                                            <li>yourlink.com</li>\r\n                                            <li>yourlink.com</li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"67%\" valign=\"top\"> <p style=\"margin-left: 4; margin-right: 4; margin-top: 9; margin-bottom: 4\" align=\"left\">&nbsp; \r\n                                </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Third \r\n                                            Story </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n</td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n</div>\r\n</body>\r\n</html>\r\n','temp1-subpage3.htm','0000-00-00 00:00:00'),(10,6,'template 2 - subpage 4','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"793\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td width=\"256\"><div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><strong>YOUR \r\n                LOGO HERE</strong></font></div></td>\r\n            <td><img src=\"@@ROOT_URL@@/images/banner_top_r1_c8.jpg\" width=\"343\" height=\"86\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 1</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"425\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"382\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"347\" valign=\"top\" class=\"bodytext\"> <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"33%\" height=\"745\" valign=\"top\"> \r\n                                <div align=\"center\">\r\n<center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#000000\" width=\"89%\" id=\"AutoNumber8\" height=\"1\" bgcolor=\"#FFFFFF\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#6600CC\" height=\"1\" bordercolor=\"#000000\" align=\"center\" style=\"border-left-color: #000000; border-left-width: 1; border-right-color: #000000; border-right-width: 1\"> \r\n                                          <b><font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                          Menu</font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#FFFFFF\" height=\"1\" bordercolor=\"#000000\" style=\"border-left-style: solid; border-left-width: 1; border-right-style: solid; border-right-width: 1; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\"> \r\n                                          <ul>\r\n                                            <li> <font face=\"Arial\" size=\"2\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=6\">Main \r\n                                              Article </a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=6\">Second \r\n                                              Story</a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=6\">Third \r\n                                              Story</a></font></li>\r\n                                            <li><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=6\"><font size=\"2\" face=\"Arial\">Fourth \r\n                                              Story</font></a><font size=\"2\" face=\"Arial\"> \r\n                                              </font></li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div>\r\n                                <p align=\"center\" style=\"margin-top: 0; margin-bottom: 0\">&nbsp; \r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"90%\" id=\"AutoNumber12\" height=\"1\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#6600CC\" height=\"1\"> \r\n                                          <p align=\"center\"><b> <font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Fourth \r\n                                            Story </font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#FFFFFF\" height=\"18\" valign=\"top\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><img src=\"@@ROOT_URL@@/images/image-small.gif\" width=\"150\" height=\"150\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\">&nbsp; \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">This \r\n                                            is the intro text for this article. \r\n                                            This is the intro text for this article.This \r\n                                            is the intro text for this article.This \r\n                                            is the intro text for this article.</font><br>\r\n                                            <a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=6\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">Find \r\n                                            out more.... </font></a> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font face=\"Arial, Helvetica, sans-serif\"><strong>More \r\n                                            Information...</strong></font> \r\n                                          <ul>\r\n                                            <li>yourlink.com</li>\r\n                                            <li>yourlink.com</li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"67%\" valign=\"top\"> <p style=\"margin-left: 4; margin-right: 4; margin-top: 9; margin-bottom: 4\" align=\"left\">&nbsp; \r\n                                </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Fourth \r\n                                            Story </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n</td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n</div>\r\n</body>\r\n</html>\r\n','temp1-subpage4.htm','0000-00-00 00:00:00'),(11,0,'template3','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title></title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"793\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td valign=\"top\"> \r\n              <div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><strong><img src=\"@@ROOT_URL@@/images/header.gif\" width=\"599\" height=\"86\"><br>\r\n                </strong></font></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 1</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"425\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"382\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"878\" valign=\"top\" class=\"bodytext\"> \r\n                          <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"33%\" height=\"745\" valign=\"top\"> \r\n                                <div align=\"center\">\r\n<center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#000000\" width=\"89%\" id=\"AutoNumber8\" height=\"1\" bgcolor=\"#FFFFFF\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#0066FF\" height=\"1\" bordercolor=\"#000000\" align=\"center\" style=\"border-left-color: #000000; border-left-width: 1; border-right-color: #000000; border-right-width: 1\"> \r\n                                          <b><font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                          Menu</font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#FFFFFF\" height=\"1\" bordercolor=\"#000000\" style=\"border-left-style: solid; border-left-width: 1; border-right-style: solid; border-right-width: 1; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\"> \r\n                                          <ul>\r\n                                            <li> <font face=\"Arial\" size=\"2\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=11\">Main \r\n                                              Article </a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=11\">Second \r\n                                              Story</a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=11\">Third \r\n                                              Story</a></font></li>\r\n                                            <li><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=11\"><font size=\"2\" face=\"Arial\">Fourth \r\n                                              Story</font></a><font size=\"2\" face=\"Arial\"> \r\n                                              </font></li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div>\r\n                                <p align=\"center\" style=\"margin-top: 0; margin-bottom: 0\">&nbsp; \r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"90%\" id=\"AutoNumber12\" height=\"1\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#0066FF\" height=\"1\"> \r\n                                          <p align=\"center\"><b> <font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Spotlight \r\n                                            Article </font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#FFFFFF\" height=\"18\" valign=\"top\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><img src=\"@@ROOT_URL@@/images/image2.jpg\" width=\"150\" height=\"150\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\">&nbsp; \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">This \r\n                                            is the intro text for this article. \r\n                                            This is the intro text for this article.This \r\n                                            is the intro text for this article.This \r\n                                            is the intro text for this article.</font><br>\r\n                                            <a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=11\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">Find \r\n                                            out more.... </font></a> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font face=\"Arial, Helvetica, sans-serif\"><strong>More \r\n                                            Information...</strong></font> \r\n                                          <ul>\r\n                                            <li>yourlink.com</li>\r\n                                            <li>yourlink.com</li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"67%\" valign=\"top\">\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Main \r\n                                            Article</strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n						This is the text for main article.\r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=11\"><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image121111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Second \r\n                                            Newsletter Story</strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=11\"><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image12111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Third \r\n                                            Newsletter Story</strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=11\"><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image121111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Fourth \r\n                                            Newsletter Story</strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=11\"><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image1211111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p></p>\r\n                                <p>&nbsp; </p>\r\n</td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">\r\n    <tr>\r\n      <td class=\"copyright\">&nbsp;</td>\r\n    </tr>\r\n  </table>\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp3.htm','0000-00-00 00:00:00'),(12,11,'template 3 - subpage 1','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"793\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td width=\"256\"><div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><strong>YOUR \r\n                LOGO HERE</strong></font></div></td>\r\n            <td><img src=\"@@ROOT_URL@@/images/banner_top_r1_c8.jpg\" width=\"343\" height=\"86\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 1</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"425\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"382\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"347\" valign=\"top\" class=\"bodytext\"> <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"33%\" height=\"745\" valign=\"top\"> \r\n                                <div align=\"center\">\r\n<center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#000000\" width=\"89%\" id=\"AutoNumber8\" height=\"1\" bgcolor=\"#FFFFFF\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#6600CC\" height=\"1\" bordercolor=\"#000000\" align=\"center\" style=\"border-left-color: #000000; border-left-width: 1; border-right-color: #000000; border-right-width: 1\"> \r\n                                          <b><font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                          Menu</font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#FFFFFF\" height=\"1\" bordercolor=\"#000000\" style=\"border-left-style: solid; border-left-width: 1; border-right-style: solid; border-right-width: 1; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\"> \r\n                                          <ul>\r\n                                            <li> <font face=\"Arial\" size=\"2\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=11\">Main \r\n                                              Article </a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=11\">Second \r\n                                              Story</a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=11\">Third \r\n                                              Story</a></font></li>\r\n                                            <li><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=11\"><font size=\"2\" face=\"Arial\">Fourth \r\n                                              Story</font></a><font size=\"2\" face=\"Arial\"> \r\n                                              </font></li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div>\r\n                                <p align=\"center\" style=\"margin-top: 0; margin-bottom: 0\">&nbsp; \r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"90%\" id=\"AutoNumber12\" height=\"1\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#6600CC\" height=\"1\"> \r\n                                          <p align=\"center\"><b> <font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                            Article </font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#FFFFFF\" height=\"18\" valign=\"top\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><img src=\"@@ROOT_URL@@/images/image-small.gif\" width=\"150\" height=\"150\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\">&nbsp; \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">This \r\n                                            is the intro text for this article. \r\n                                            This is the intro text for this article.This \r\n                                            is the intro text for this article.This \r\n                                            is the intro text for this article.</font><br>\r\n                                            <a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=11\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">Find \r\n                                            out more.... </font></a> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font face=\"Arial, Helvetica, sans-serif\"><strong>More \r\n                                            Information...</strong></font> \r\n                                          <ul>\r\n                                            <li>yourlink.com</li>\r\n                                            <li>yourlink.com</li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"67%\" valign=\"top\"> <p style=\"margin-left: 4; margin-right: 4; margin-top: 9; margin-bottom: 4\" align=\"left\">&nbsp; \r\n                                </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Main \r\n                                            Article </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n</td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n</div>\r\n</body>\r\n</html>\r\n','temp1-subpage1.htm','0000-00-00 00:00:00'),(13,11,'template 3 - subpage 2','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"793\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td width=\"256\"><div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><strong>YOUR \r\n                LOGO HERE</strong></font></div></td>\r\n            <td><img src=\"@@ROOT_URL@@/images/banner_top_r1_c8.jpg\" width=\"343\" height=\"86\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 1</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"425\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"382\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"347\" valign=\"top\" class=\"bodytext\"> <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"33%\" height=\"745\" valign=\"top\"> \r\n                                <div align=\"center\">\r\n<center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#000000\" width=\"89%\" id=\"AutoNumber8\" height=\"1\" bgcolor=\"#FFFFFF\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#6600CC\" height=\"1\" bordercolor=\"#000000\" align=\"center\" style=\"border-left-color: #000000; border-left-width: 1; border-right-color: #000000; border-right-width: 1\"> \r\n                                          <b><font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                          Menu</font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#FFFFFF\" height=\"1\" bordercolor=\"#000000\" style=\"border-left-style: solid; border-left-width: 1; border-right-style: solid; border-right-width: 1; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\"> \r\n                                          <ul>\r\n                                            <li> <font face=\"Arial\" size=\"2\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=11\">Main \r\n                                              Article </a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=11\">Second \r\n                                              Story</a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=11\">Third \r\n                                              Story</a></font></li>\r\n                                            <li><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=11\"><font size=\"2\" face=\"Arial\">Fourth \r\n                                              Story</font></a><font size=\"2\" face=\"Arial\"> \r\n                                              </font></li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div>\r\n                                <p align=\"center\" style=\"margin-top: 0; margin-bottom: 0\">&nbsp; \r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"90%\" id=\"AutoNumber12\" height=\"1\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#6600CC\" height=\"1\"> \r\n                                          <p align=\"center\"><b> <font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Second \r\n                                            Story </font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#FFFFFF\" height=\"18\" valign=\"top\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><img src=\"@@ROOT_URL@@/images/image-small.gif\" width=\"150\" height=\"150\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\">&nbsp; \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">This \r\n                                            is the intro text for this article. \r\n                                            This is the intro text for this article.This \r\n                                            is the intro text for this article.This \r\n                                            is the intro text for this article.</font><br>\r\n                                            <a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=11\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">Find \r\n                                            out more.... </font></a> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font face=\"Arial, Helvetica, sans-serif\"><strong>More \r\n                                            Information...</strong></font> \r\n                                          <ul>\r\n                                            <li>yourlink.com</li>\r\n                                            <li>yourlink.com</li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"67%\" valign=\"top\"> <p style=\"margin-left: 4; margin-right: 4; margin-top: 9; margin-bottom: 4\" align=\"left\">&nbsp; \r\n                                </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Second \r\n                                            Story </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n</td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n</td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n</div>\r\n</body>\r\n</html>\r\n','temp1-subpage2.htm','0000-00-00 00:00:00'),(14,11,'template 3 - subpage 3','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"793\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td width=\"256\"><div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><strong>YOUR \r\n                LOGO HERE</strong></font></div></td>\r\n            <td><img src=\"@@ROOT_URL@@/images/banner_top_r1_c8.jpg\" width=\"343\" height=\"86\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 1</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"425\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"382\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"347\" valign=\"top\" class=\"bodytext\"> <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"33%\" height=\"745\" valign=\"top\"> \r\n                                <div align=\"center\">\r\n<center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#000000\" width=\"89%\" id=\"AutoNumber8\" height=\"1\" bgcolor=\"#FFFFFF\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#6600CC\" height=\"1\" bordercolor=\"#000000\" align=\"center\" style=\"border-left-color: #000000; border-left-width: 1; border-right-color: #000000; border-right-width: 1\"> \r\n                                          <b><font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                          Menu</font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#FFFFFF\" height=\"1\" bordercolor=\"#000000\" style=\"border-left-style: solid; border-left-width: 1; border-right-style: solid; border-right-width: 1; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\"> \r\n                                          <ul>\r\n                                            <li> <font face=\"Arial\" size=\"2\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=11\">Main \r\n                                              Article </a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=11\">Second \r\n                                              Story</a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=11\">Third \r\n                                              Story</a></font></li>\r\n                                            <li><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=11\"><font size=\"2\" face=\"Arial\">Fourth \r\n                                              Story</font></a><font size=\"2\" face=\"Arial\"> \r\n                                              </font></li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div>\r\n                                <p align=\"center\" style=\"margin-top: 0; margin-bottom: 0\">&nbsp; \r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"90%\" id=\"AutoNumber12\" height=\"1\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#6600CC\" height=\"1\"> \r\n                                          <p align=\"center\"><b> <font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Third \r\n                                            Story </font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#FFFFFF\" height=\"18\" valign=\"top\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><img src=\"@@ROOT_URL@@/images/image-small.gif\" width=\"150\" height=\"150\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\">&nbsp; \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">This \r\n                                            is the intro text for this article. \r\n                                            This is the intro text for this article.This \r\n                                            is the intro text for this article.This \r\n                                            is the intro text for this article.</font><br>\r\n                                            <a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=11\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">Find \r\n                                            out more.... </font></a> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font face=\"Arial, Helvetica, sans-serif\"><strong>More \r\n                                            Information...</strong></font> \r\n                                          <ul>\r\n                                            <li>yourlink.com</li>\r\n                                            <li>yourlink.com</li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"67%\" valign=\"top\"> <p style=\"margin-left: 4; margin-right: 4; margin-top: 9; margin-bottom: 4\" align=\"left\">&nbsp; \r\n                                </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Third \r\n                                            Story </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n</td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n</div>\r\n</body>\r\n</html>\r\n','temp1-subpage3.htm','0000-00-00 00:00:00'),(15,11,'template 3 - subpage 4','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"793\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td width=\"256\"><div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><strong>YOUR \r\n                LOGO HERE</strong></font></div></td>\r\n            <td><img src=\"@@ROOT_URL@@/images/banner_top_r1_c8.jpg\" width=\"343\" height=\"86\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 1</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"425\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"382\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"347\" valign=\"top\" class=\"bodytext\"> <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"33%\" height=\"745\" valign=\"top\"> \r\n                                <div align=\"center\">\r\n<center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#000000\" width=\"89%\" id=\"AutoNumber8\" height=\"1\" bgcolor=\"#FFFFFF\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#6600CC\" height=\"1\" bordercolor=\"#000000\" align=\"center\" style=\"border-left-color: #000000; border-left-width: 1; border-right-color: #000000; border-right-width: 1\"> \r\n                                          <b><font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Main \r\n                                          Menu</font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" bgcolor=\"#FFFFFF\" height=\"1\" bordercolor=\"#000000\" style=\"border-left-style: solid; border-left-width: 1; border-right-style: solid; border-right-width: 1; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\"> \r\n                                          <ul>\r\n                                            <li> <font face=\"Arial\" size=\"2\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=11\">Main \r\n                                              Article </a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=11\">Second \r\n                                              Story</a></font></li>\r\n                                            <li><font size=\"2\" face=\"Arial\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=11\">Third \r\n                                              Story</a></font></li>\r\n                                            <li><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id4&id=11\"><font size=\"2\" face=\"Arial\">Fourth \r\n                                              Story</font></a><font size=\"2\" face=\"Arial\"> \r\n                                              </font></li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div>\r\n                                <p align=\"center\" style=\"margin-top: 0; margin-bottom: 0\">&nbsp; \r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                    <table border=\"1\" cellpadding=\"0\" cellspacing=\"0\" style=\"border-collapse: collapse\" bordercolor=\"#111111\" width=\"90%\" id=\"AutoNumber12\" height=\"1\">\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#6600CC\" height=\"1\"> \r\n                                          <p align=\"center\"><b> <font face=\"Arial\" size=\"2\" color=\"#FFFFFF\">Fourth \r\n                                            Story </font></b></td>\r\n                                      </tr>\r\n                                      <tr> \r\n                                        <td width=\"100%\" style=\"border-style: none; border-width: medium\" bgcolor=\"#FFFFFF\" height=\"18\" valign=\"top\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><img src=\"@@ROOT_URL@@/images/image-small.gif\" width=\"150\" height=\"150\"> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\">&nbsp; \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">This \r\n                                            is the intro text for this article. \r\n                                            This is the intro text for this article.This \r\n                                            is the intro text for this article.This \r\n                                            is the intro text for this article.</font><br>\r\n                                            <a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=11\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">Find \r\n                                            out more.... </font></a> \r\n                                          <p style=\"margin-left: 5; margin-top: 9; margin-bottom: 9\"><font face=\"Arial, Helvetica, sans-serif\"><strong>More \r\n                                            Information...</strong></font> \r\n                                          <ul>\r\n                                            <li>yourlink.com</li>\r\n                                            <li>yourlink.com</li>\r\n                                          </ul></td>\r\n                                      </tr>\r\n                                    </table>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"67%\" valign=\"top\"> <p style=\"margin-left: 4; margin-right: 4; margin-top: 9; margin-bottom: 4\" align=\"left\">&nbsp; \r\n                                </p>\r\n                                <table width=\"393\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"393\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"392\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td width=\"382\" bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Fourth \r\n                                            Story </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                              is currently easier than ever to \r\n                                              sell products online. Through the \r\n                                              use of integrated solutions that \r\n                                              provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              <br>\r\n                                              It is currently easier than ever \r\n                                              to sell products online. Through \r\n                                              the use of integrated solutions \r\n                                              that provide the traditional shopping \r\n                                              cart functionality and a seamless \r\n                                              integration into a payment gateway \r\n                                              </font> </p></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p>&nbsp; </p>\r\n</td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n</div>\r\n</body>\r\n</html>\r\n','temp1-subpage4.htm','0000-00-00 00:00:00'),(16,0,'template4','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"649\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td> <div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><img src=\"@@ROOT_URL@@/images/header.gif\" width=\"599\" height=\"86\"></font></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 2</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"468\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"399\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"361\" valign=\"top\" class=\"bodytext\"> \r\n                          <table width=\"99%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"71%\" height=\"280\" valign=\"top\"> <div align=\"left\"> \r\n                                  <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                    is currently easier than ever to sell products \r\n                                    online. Through the use of</font><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">integrated \r\n                                    solutions that provide the traditional shopping \r\n                                    cart functionality and a seamless integration \r\n                                    into a payment gateway <br>\r\n                                    It is currently easier than ever to sell products \r\n                                    online. Through the use of integrated solutions \r\n                                    that provide the traditional shopping cart \r\n                                    functionality and a seamless integration into \r\n                                    a payment gateway<br>\r\n                                    It is currently easier than ever to sell products \r\n                                    online. Through the use of integrated solutions \r\n                                    that provide the traditional shopping cart \r\n                                    functionality and a seamless integration into \r\n                                    a payment gateway <br>\r\n                                    It is currently easier than ever to sell products \r\n                                    online. Through the use of integrated solutions \r\n                                    that provide the traditional shopping cart \r\n                                    functionality and a seamless integration into \r\n                                    a payment gateway <br>\r\n                                    It is currently easier than ever to sell products \r\n                                    online. Through the use of integrated solutions \r\n                                    that provide the traditional shopping cart \r\n                                    functionality and a seamless integration into \r\n                                    a payment gateway <br>\r\n                                    </font></p>\r\n                                </div>\r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"29%\" valign=\"top\"><img src=\"@@ROOT_URL@@/images/image2.jpg\" width=\"150\" height=\"150\"></td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">\r\n    <tr>\r\n      <td class=\"copyright\">&nbsp;</td>\r\n    </tr>\r\n  </table>\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp4.htm','0000-00-00 00:00:00'),(17,0,'template5','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"631\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td> <div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><br>\r\n                YOUR SLOGAN HERE<br>\r\n                <br>\r\n                <br>\r\n                </font></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 2</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"468\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"399\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"361\" valign=\"top\" class=\"bodytext\"> <table width=\"99%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"71%\" height=\"280\" valign=\"top\"> <div align=\"left\"> \r\n                                  <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                    is currently easier than ever to sell products \r\n                                    online. Through the use of</font><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">integrated \r\n                                    solutions that provide the traditional shopping \r\n                                    cart functionality and a seamless integration \r\n                                    into a payment gateway <br>\r\n                                    It is currently easier than ever to sell products \r\n                                    online. Through the use of integrated solutions \r\n                                    that provide the traditional shopping cart \r\n                                    functionality and a seamless integration into \r\n                                    a payment gateway<br>\r\n                                    It is currently easier than ever to sell products \r\n                                    online. Through the use of integrated solutions \r\n                                    that provide the traditional shopping cart \r\n                                    functionality and a seamless integration into \r\n                                    a payment gateway <br>\r\n                                    It is currently easier than ever to sell products \r\n                                    online. Through the use of integrated solutions \r\n                                    that provide the traditional shopping cart \r\n                                    functionality and a seamless integration into \r\n                                    a payment gateway <br>\r\n                                    It is currently easier than ever to sell products \r\n                                    online. Through the use of integrated solutions \r\n                                    that provide the traditional shopping cart \r\n                                    functionality and a seamless integration into \r\n                                    a payment gateway <br>\r\n                                    </font></p>\r\n                                </div>\r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"29%\" valign=\"top\"><img src=\"@@ROOT_URL@@/images/image2.jpg\" width=\"150\" height=\"150\"></td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp5.htm','0000-00-00 00:00:00'),(18,0,'template6','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"649\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td width=\"256\"> <div align=\"center\">YOUR LOGO HERE</div></td>\r\n            <td width=\"343\"><img src=\"@@ROOT_URL@@/images/banner_top_r1_c8.jpg\" width=\"343\" height=\"86\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 2</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"468\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"399\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\">Newsletter \r\n                          Sub-title</td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"361\" valign=\"top\" class=\"bodytext\"> <table width=\"99%\" border=\"0\">\r\n                            <tr> \r\n                              <td width=\"71%\" height=\"280\" valign=\"top\"> <div align=\"left\"> \r\n                                  <p><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                    is currently easier than ever to sell products \r\n                                    online. Through the use of</font><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">integrated \r\n                                    solutions that provide the traditional shopping \r\n                                    cart functionality and a seamless integration \r\n                                    into a payment gateway <br>\r\n                                    It is currently easier than ever to sell products \r\n                                    online. Through the use of integrated solutions \r\n                                    that provide the traditional shopping cart \r\n                                    functionality and a seamless integration into \r\n                                    a payment gateway<br>\r\n                                    It is currently easier than ever to sell products \r\n                                    online. Through the use of integrated solutions \r\n                                    that provide the traditional shopping cart \r\n                                    functionality and a seamless integration into \r\n                                    a payment gateway <br>\r\n                                    It is currently easier than ever to sell products \r\n                                    online. Through the use of integrated solutions \r\n                                    that provide the traditional shopping cart \r\n                                    functionality and a seamless integration into \r\n                                    a payment gateway <br>\r\n                                    It is currently easier than ever to sell products \r\n                                    online. Through the use of integrated solutions \r\n                                    that provide the traditional shopping cart \r\n                                    functionality and a seamless integration into \r\n                                    a payment gateway <br>\r\n                                    </font></p>\r\n                                </div>\r\n                                <div align=\"center\"> \r\n                                  <center>\r\n                                  </center>\r\n                                </div></td>\r\n                              <td width=\"29%\" valign=\"top\"><img src=\"@@ROOT_URL@@/images/image2.jpg\" width=\"150\" height=\"150\"></td>\r\n                            </tr>\r\n                          </table>\r\n                          <p><br>\r\n                          </p>\r\n                          </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">\r\n    <tr>\r\n      <td class=\"copyright\">&nbsp;</td>\r\n    </tr>\r\n  </table>\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp6.htm','0000-00-00 00:00:00'),(19,0,'template7','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\" >\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"1038\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td> <div align=\"center\"><font size=\"3\" face=\"Arial, Helvetica, sans-serif\"><img src=\"@@ROOT_URL@@/images/header.gif\" width=\"599\" height=\"86\"></font></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 3</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"468\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"1014\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Newsletter \r\n                          Sub-title</strong></font></td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"983\" valign=\"top\" class=\"bodytext\"> \r\n                          <table width=\"35%\" border=\"0\">\r\n                            <tr>\r\n                              <td height=\"248\">\r\n<table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td colspan=\"2\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>First \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td width=\"132\" height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><img src=\"@@ROOT_URL@@/images/image2.jpg\" width=\"150\" height=\"150\"> \r\n                                            </p></td>\r\n                                          <td width=\"410\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=19\" ><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image12111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p></p>\r\n                          </td>\r\n                            </tr>\r\n                            <tr>\r\n                              <td><table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td colspan=\"2\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Second \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td width=\"132\" height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><img src=\"@@ROOT_URL@@/images/image2.jpg\" width=\"150\" height=\"150\"> \r\n                                            </p></td>\r\n                                          <td width=\"410\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=19\" ><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image121111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p></p>\r\n                          </td>\r\n                            </tr>\r\n                            <tr>\r\n                              <td><table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td colspan=\"2\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Third \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td width=\"132\" height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><img src=\"@@ROOT_URL@@/images/image2.jpg\" width=\"150\" height=\"150\"> \r\n                                            </p></td>\r\n                                          <td width=\"410\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=19\" ><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image1211111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                          </td>\r\n                            </tr>\r\n                          </table>\r\n                          \r\n                        </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">\r\n    <tr>\r\n      <td class=\"copyright\">&nbsp;</td>\r\n    </tr>\r\n  </table>\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp7.htm','0000-00-00 00:00:00'),(20,19,'template 7 - subpage 1','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title></title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"700\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td> <div align=\"center\"><font size=\"3\"><strong><br>\r\n                YOUR SLOGAN HERE<br>\r\n                <br>\r\n                <br>\r\n                </strong></font></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 3</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"533\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"474\" valign=\"top\"> \r\n                    <table width=\"102%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Newsletter \r\n                          Sub-title</strong></font></td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"443\" valign=\"top\" class=\"bodytext\"> \r\n                          <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td><table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>First \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=19\" ><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image12111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p></td>\r\n                            </tr>\r\n                          </table>\r\n                          \r\n                        </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\">&nbsp;</td>\r\n                    <td width=\"87\">&nbsp;</td>\r\n                    <td width=\"80\">&nbsp;</td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp7-subpage1.htm','0000-00-00 00:00:00'),(21,19,'template 7 - subpage 2','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title></title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"700\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td> <div align=\"center\"><font size=\"3\"><strong><br>\r\n                YOUR SLOGAN HERE<br>\r\n                <br>\r\n                <br>\r\n                </strong></font></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 3</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"533\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"474\" valign=\"top\"> \r\n                    <table width=\"102%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Newsletter \r\n                          Sub-title</strong></font></td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"443\" valign=\"top\" class=\"bodytext\"> \r\n                          <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td><table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Second \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=19\" ><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image12111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p></td>\r\n                            </tr>\r\n                          </table>\r\n                          \r\n                        </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\">&nbsp;</td>\r\n                    <td width=\"87\">&nbsp;</td>\r\n                    <td width=\"80\">&nbsp;</td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp7-subpage2.htm','0000-00-00 00:00:00'),(22,19,'template 7 - subpage 3','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title></title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"700\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td> <div align=\"center\"><font size=\"3\"><strong><br>\r\n                YOUR SLOGAN HERE<br>\r\n                <br>\r\n                <br>\r\n                </strong></font></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 3</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"533\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"474\" valign=\"top\"> \r\n                    <table width=\"102%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Newsletter \r\n                          Sub-title</strong></font></td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"443\" valign=\"top\" class=\"bodytext\"> \r\n                          <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td><table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Third \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=19\" ><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image12111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p></td>\r\n                            </tr>\r\n                          </table>\r\n                          \r\n                        </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\">&nbsp;</td>\r\n                    <td width=\"87\">&nbsp;</td>\r\n                    <td width=\"80\">&nbsp;</td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp7-subpage3.htm','0000-00-00 00:00:00'),(23,0,'template8','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\" >\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"1038\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr><td width=\"256\"> <div align=\"center\"><font size=\"3\"><strong>YOUR LOGO \r\n                HERE</strong></font></div></td>\r\n            <td width=\"343\"><img src=\"@@ROOT_URL@@/images/banner_top_r1_c8.jpg\" width=\"343\" height=\"86\"></td>\r\n           \r\n            <td> <div align=\"center\"></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 3</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"468\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"1014\" valign=\"top\"> \r\n                    <table width=\"100%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Newsletter \r\n                          Sub-title</strong></font></td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"983\" valign=\"top\" class=\"bodytext\"> \r\n                          <table width=\"35%\" border=\"0\">\r\n                            <tr>\r\n                              <td height=\"248\">\r\n<table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td colspan=\"2\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>First \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td width=\"132\" height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><img src=\"@@ROOT_URL@@/images/image2.jpg\" width=\"150\" height=\"150\"> \r\n                                            </p></td>\r\n                                          <td width=\"410\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=23\"><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image12111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p></p>\r\n                          </td>\r\n                            </tr>\r\n                            <tr>\r\n                              <td><table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td colspan=\"2\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Second \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td width=\"132\" height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><img src=\"@@ROOT_URL@@/images/image2.jpg\" width=\"150\" height=\"150\"> \r\n                                            </p></td>\r\n                                          <td width=\"410\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=23\"><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image121111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p></p>\r\n                          </td>\r\n                            </tr>\r\n                            <tr>\r\n                              <td><table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td colspan=\"2\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Third \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td width=\"132\" height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><img src=\"@@ROOT_URL@@/images/image2.jpg\" width=\"150\" height=\"150\"> \r\n                                            </p></td>\r\n                                          <td width=\"410\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=23\"><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image1211111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                          </td>\r\n                            </tr>\r\n                          </table>\r\n                          \r\n                        </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"87\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                    <td width=\"80\"><div align=\"center\" class=\"bottomlinks\"></div></td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">\r\n    <tr>\r\n      <td class=\"copyright\">&nbsp;</td>\r\n    </tr>\r\n  </table>\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp8.htm','0000-00-00 00:00:00'),(24,23,'template 8 - subpage 1','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title></title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"700\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td> <div align=\"center\"><font size=\"3\"><strong><br>\r\n                YOUR SLOGAN HERE<br>\r\n                <br>\r\n                <br>\r\n                </strong></font></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 3</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"533\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"474\" valign=\"top\"> \r\n                    <table width=\"102%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Newsletter \r\n                          Sub-title</strong></font></td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"443\" valign=\"top\" class=\"bodytext\"> \r\n                          <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td><table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>First \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=23\" ><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image12111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p></td>\r\n                            </tr>\r\n                          </table>\r\n                          \r\n                        </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\">&nbsp;</td>\r\n                    <td width=\"87\">&nbsp;</td>\r\n                    <td width=\"80\">&nbsp;</td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp7-subpage1.htm','0000-00-00 00:00:00'),(25,23,'template 8 - subpage 2','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title></title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"700\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td> <div align=\"center\"><font size=\"3\"><strong><br>\r\n                YOUR SLOGAN HERE<br>\r\n                <br>\r\n                <br>\r\n                </strong></font></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 3</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"533\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"474\" valign=\"top\"> \r\n                    <table width=\"102%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Newsletter \r\n                          Sub-title</strong></font></td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"443\" valign=\"top\" class=\"bodytext\"> \r\n                          <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td><table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Second \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=23\" ><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image12111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p></td>\r\n                            </tr>\r\n                          </table>\r\n                          \r\n                        </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\">&nbsp;</td>\r\n                    <td width=\"87\">&nbsp;</td>\r\n                    <td width=\"80\">&nbsp;</td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp7-subpage2.htm','0000-00-00 00:00:00'),(26,23,'template 8 - subpage 3','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title></title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"700\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td> <div align=\"center\"><font size=\"3\"><strong><br>\r\n                YOUR SLOGAN HERE<br>\r\n                <br>\r\n                <br>\r\n                </strong></font></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 3</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"533\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"474\" valign=\"top\"> \r\n                    <table width=\"102%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Newsletter \r\n                          Sub-title</strong></font></td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"443\" valign=\"top\" class=\"bodytext\"> \r\n                          <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td><table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Third \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=23\" ><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image12111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p></td>\r\n                            </tr>\r\n                          </table>\r\n                          \r\n                        </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\">&nbsp;</td>\r\n                    <td width=\"87\">&nbsp;</td>\r\n                    <td width=\"80\">&nbsp;</td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp7-subpage3.htm','0000-00-00 00:00:00'),(27,0,'template9','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title>Mailing HTML</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"1044\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td> <div align=\"center\"><font size=\"3\"><strong><br>\r\n                YOUR LOGO SLOGAN HERE<br>\r\n                <br>\r\n                <br>\r\n                </strong></font></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 3</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"848\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"807\" valign=\"top\"> \r\n                    <table width=\"102%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Newsletter \r\n                          Sub-title</strong></font></td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"776\" valign=\"top\" class=\"bodytext\"> \r\n                          <table width=\"100%\" border=\"0\">\r\n                            <tr>\r\n                              <td><table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td colspan=\"2\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>First \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td width=\"132\" height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><img src=\"@@ROOT_URL@@/images/image2.jpg\" width=\"150\" height=\"150\"> \r\n                                            </p></td>\r\n                                          <td width=\"410\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=27\"><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image12111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                          </td>\r\n                            </tr>\r\n                            <tr>\r\n                              <td><p> </p>\r\n                                <table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td colspan=\"2\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Second \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td width=\"132\" height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><img src=\"@@ROOT_URL@@/images/image2.jpg\" width=\"150\" height=\"150\"> \r\n                                            </p></td>\r\n                                          <td width=\"410\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id2&id=27\"><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image121111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                          </td>\r\n                            </tr>\r\n                            <tr>\r\n                              <td height=\"250\"> \r\n                                <table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td colspan=\"2\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Third \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td width=\"132\" height=\"174\" valign=\"top\" class=\"bodytext\"> \r\n                                            <p><img src=\"@@ROOT_URL@@/images/image2.jpg\" width=\"150\" height=\"150\"> \r\n                                            </p></td>\r\n                                          <td width=\"410\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id3&id=27\"><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image1211111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p>\r\n                                <p></p>\r\n                          </td>\r\n                            </tr>\r\n                          </table>\r\n                          \r\n                        </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\">&nbsp;</td>\r\n                    <td width=\"87\">&nbsp;</td>\r\n                    <td width=\"80\">&nbsp;</td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp9.htm','0000-00-00 00:00:00'),(28,27,'template 9 - subpage 1','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title></title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"700\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td> <div align=\"center\"><font size=\"3\"><strong><br>\r\n                YOUR SLOGAN HERE<br>\r\n                <br>\r\n                <br>\r\n                </strong></font></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 3</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"533\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"474\" valign=\"top\"> \r\n                    <table width=\"102%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Newsletter \r\n                          Sub-title</strong></font></td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"443\" valign=\"top\" class=\"bodytext\"> \r\n                          <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td><table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>First \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=27\" ><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image12111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p></td>\r\n                            </tr>\r\n                          </table>\r\n                          \r\n                        </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\">&nbsp;</td>\r\n                    <td width=\"87\">&nbsp;</td>\r\n                    <td width=\"80\">&nbsp;</td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp7-subpage1.htm','0000-00-00 00:00:00'),(29,27,'template 9 - subpage 2','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title></title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"700\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td> <div align=\"center\"><font size=\"3\"><strong><br>\r\n                YOUR SLOGAN HERE<br>\r\n                <br>\r\n                <br>\r\n                </strong></font></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 3</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"533\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"474\" valign=\"top\"> \r\n                    <table width=\"102%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Newsletter \r\n                          Sub-title</strong></font></td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"443\" valign=\"top\" class=\"bodytext\"> \r\n                          <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td><table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Second \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=27\" ><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image12111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p></td>\r\n                            </tr>\r\n                          </table>\r\n                          \r\n                        </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\">&nbsp;</td>\r\n                    <td width=\"87\">&nbsp;</td>\r\n                    <td width=\"80\">&nbsp;</td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp7-subpage2.htm','0000-00-00 00:00:00'),(30,27,'template 9 - subpage 3','<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n<html>\r\n<head>\r\n<title></title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\r\n<link href=\"@@ROOT_URL@@/templates/styles.css\" rel=\"stylesheet\" type=\"text/css\">\r\n</head>\r\n\r\n<body bgcolor=\"#f0f0f0\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\r\n<div align=\"center\">\r\n  <table width=\"601\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n    <tr>\r\n      <td width=\"1\" height=\"700\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n      <td width=\"599\" valign=\"top\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td> <div align=\"center\"><font size=\"3\"><strong><br>\r\n                YOUR SLOGAN HERE<br>\r\n                <br>\r\n                <br>\r\n                </strong></font></div></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"24\"><table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                <tr> \r\n                  <td width=\"145\" height=\"24\" bgcolor=\"#FFFFFF\"><div align=\"center\"><span class=\"time\"> \r\n                      <!-- #BeginDate format:Am1 -->July 8, 2004<!-- #EndDate -->\r\n                      </span></div></td>\r\n                  <td width=\"7\" height=\"24\"><img src=\"@@ROOT_URL@@/images/title_left.jpg\" width=\"7\" height=\"24\"></td>\r\n                  <td bgcolor=\"#333366\" class=\"maintitle\"><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                      <tr>\r\n                        <td width=\"5\">&nbsp;</td>\r\n                        <td class=\"maintitle\"><font color=\"#FFFFFF\"><strong>NEWSLETTER \r\n                          TEMPLATE 3</strong></font></td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n              </table></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"1\" background=\"@@ROOT_URL@@/images/divider_line_top.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_top.gif\" width=\"41\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr> \r\n            <td height=\"533\" valign=\"top\" bgcolor=\"#FBFBFB\"><br>\r\n              <table width=\"577\" border=\"0\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                <tr> \r\n                  <td width=\"575\" height=\"474\" valign=\"top\"> \r\n                    <table width=\"102%\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                      <tr> \r\n                        <td bgcolor=\"#f0f0f0\" class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Newsletter \r\n                          Sub-title</strong></font></td>\r\n                      </tr>\r\n                      <tr> \r\n                        <td height=\"443\" valign=\"top\" class=\"bodytext\"> \r\n                          <table width=\"100%\" border=\"0\">\r\n                            <tr> \r\n                              <td><table width=\"560\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"0\" class=\"border\">\r\n                                  <tr> \r\n                                    <td width=\"560\" height=\"207\" valign=\"top\"> \r\n                                      <table width=\"557\" border=\"0\" align=\"left\" cellpadding=\"0\" cellspacing=\"5\">\r\n                                        <tr> \r\n                                          <td class=\"bodytextCopy\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\"><strong>Third \r\n                                            Product </strong></font></td>\r\n                                        </tr>\r\n                                        <tr> \r\n                                          <td height=\"174\" valign=\"top\" class=\"bodytext\"><font size=\"2\" face=\"Verdana, Arial, Helvetica, sans-serif\">It \r\n                                            is currently easier than ever to sell \r\n                                            products online. Through the use of \r\n                                            integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway It is currently easier \r\n                                            than ever to sell products online. \r\n                                            Through the use of integrated solutions \r\n                                            that provide the traditional shopping \r\n                                            cart functionality and a seamless \r\n                                            integration into a payment gateway \r\n                                            <br>\r\n                                            It is currently easier than ever to \r\n                                            sell products online. Through the \r\n                                            use of integrated solutions that provide \r\n                                            the traditional shopping cart functionality \r\n                                            and a seamless integration into a \r\n                                            payment gateway </font></td>\r\n                                        </tr>\r\n                                      </table>\r\n                                      <br> <br> <br> <br> <br> </td>\r\n                                  </tr>\r\n                                  <tr> \r\n                                    <td height=\"15\" bgcolor=\"#CCCCCC\"><div align=\"right\"><a href=\"@@ROOT_URL@@/templates/subpage.php?op=id1&id=27\" ><img src=\"@@ROOT_URL@@/images/tab_readmore.gif\" alt=\"Read More\" name=\"Image12111\" width=\"95\" height=\"15\" border=\"0\" id=\"Image121\"></a></div></td>\r\n                                  </tr>\r\n                                </table>\r\n                                <p><br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                  <br>\r\n                                </p></td>\r\n                            </tr>\r\n                          </table>\r\n                          \r\n                        </td>\r\n                      </tr>\r\n                    </table></td>\r\n                </tr>\r\n                <tr> \r\n                  <td height=\"19\" bgcolor=\"#CCCCCC\">\r\n<div align=\"right\"></div></td>\r\n                </tr>\r\n              </table>\r\n              \r\n            </td>\r\n          </tr>\r\n        </table>\r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n          <tr>\r\n            <td bgcolor=\"#f0f0f0\"><div align=\"right\">\r\n                <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n                  <tr> \r\n                    <td width=\"343\" height=\"19\">&nbsp;</td>\r\n                    <td width=\"89\">&nbsp;</td>\r\n                    <td width=\"87\">&nbsp;</td>\r\n                    <td width=\"80\">&nbsp;</td>\r\n                  </tr>\r\n                </table>\r\n              </div></td>\r\n          </tr>\r\n          <tr>\r\n            <td background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n        <table width=\"599\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\r\n          <tr>\r\n            <td height=\"42\" valign=\"top\" bgcolor=\"#FFFFFF\"> \r\n              <div align=\"right\" class=\"copyright\"></div></td>\r\n          </tr>\r\n          <tr>\r\n            <td height=\"2\" background=\"@@ROOT_URL@@/images/divider_line_purple.gif\"><img src=\"@@ROOT_URL@@/images/divider_line_purple.gif\" width=\"30\" height=\"1\"></td>\r\n          </tr>\r\n        </table>\r\n        \r\n    \r\n      </td>\r\n      <td width=\"10\" bgcolor=\"#333366\"><img src=\"@@ROOT_URL@@/images/spacer.gif\" width=\"1\" height=\"1\"></td>\r\n    </tr>\r\n  </table>\r\n  \r\n\r\n  \r\n</div>\r\n</body>\r\n</html>\r\n','temp7-subpage3.htm','0000-00-00 00:00:00');
/*!40000 ALTER TABLE `email_templates` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `field_types`
--

DROP TABLE IF EXISTS `field_types`;
CREATE TABLE `field_types` (
  `type_id` tinyint(3) unsigned NOT NULL default '0',
  `name` varchar(48) NOT NULL default '',
  `position` float NOT NULL default '0',
  PRIMARY KEY  (`type_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Possible types of custom fields';

--
-- Dumping data for table `field_types`
--

LOCK TABLES `field_types` WRITE;
/*!40000 ALTER TABLE `field_types` DISABLE KEYS */;
INSERT INTO `field_types` VALUES (0,'Text box',1),(1,'Text Area',2),(2,'Dropdown menu',3),(3,'Radio button - display horizontally',4),(4,'Radio button - display vertically',5),(6,'Subscribe to Mailing List',7),(7,'Member login field',8),(8,'Member password field',9),(9,'Confirm password field',10),(10,'Text label',11),(11,'Date',12),(18,'State',19),(19,'Country',20),(24,'E-Mail',25),(25,'Email Format',26),(26,'Checkbox - Multi Options - Vert',6.1),(27,'Checkbox - Multi Options - Hor',6.2),(28,'Multle Selection Box',3.1),(29,'Text Box - Numerical',1.1);
/*!40000 ALTER TABLE `field_types` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `form_fields`
--

DROP TABLE IF EXISTS `form_fields`;
CREATE TABLE `form_fields` (
  `field_id` smallint(5) unsigned NOT NULL auto_increment,
  `form_id` tinyint(3) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  `required` tinyint(4) NOT NULL default '0',
  `active` tinyint(4) NOT NULL default '1',
  `search` tinyint(4) NOT NULL default '0',
  `modify` tinyint(4) NOT NULL default '1',
  `type` tinyint(4) NOT NULL default '0',
  `sort` tinyint(3) unsigned NOT NULL default '255',
  `empty_default` tinyint(3) unsigned NOT NULL default '1',
  `date_start` smallint(5) unsigned NOT NULL default '0',
  `date_end` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`field_id`),
  KEY `i_formfld_field` (`form_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Custom form fields';

--
-- Dumping data for table `form_fields`
--

LOCK TABLES `form_fields` WRITE;
/*!40000 ALTER TABLE `form_fields` DISABLE KEYS */;
/*!40000 ALTER TABLE `form_fields` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `forms`
--

DROP TABLE IF EXISTS `forms`;
CREATE TABLE `forms` (
  `form_id` tinyint(3) unsigned NOT NULL auto_increment,
  `name` varchar(64) NOT NULL default '',
  `added` datetime NOT NULL default '0000-00-00 00:00:00',
  `profile_redirect` varchar(255) NOT NULL default '',
  `share_friends_redirect` varchar(255) NOT NULL default '',
  `unsubscribe_redirect` varchar(255) NOT NULL default '',
  `validate_redirect` varchar(255) NOT NULL default '',
  `payment_gateway` tinyint(4) NOT NULL default '1',
  `gateway_login` varchar(48) NOT NULL default '',
  `gw_password` varchar(255) NOT NULL default '',
  `test_mode` tinyint(3) unsigned NOT NULL default '1',
  `transaction_key` varchar(255) NOT NULL default '',
  `amount` float NOT NULL default '0',
  `members_redirect` varchar(255) NOT NULL default '',
  `auto_subscribe` tinyint(3) unsigned NOT NULL default '1',
  `header` mediumblob,
  `header_html` text,
  `header_align` tinyint(4) NOT NULL default '1',
  `footer` mediumblob,
  `footer_html` text,
  `footer_align` tinyint(4) NOT NULL default '1',
  `no_footer` tinyint(3) unsigned NOT NULL default '0',
  `logo_bg` varchar(32) NOT NULL default '#ffffff',
  `popup` tinyint(3) unsigned NOT NULL default '1',
  `outline_border` tinyint(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (`form_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Contact forms';

--
-- Dumping data for table `forms`
--

LOCK TABLES `forms` WRITE;
/*!40000 ALTER TABLE `forms` DISABLE KEYS */;
/*!40000 ALTER TABLE `forms` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `forms_responders`
--

DROP TABLE IF EXISTS `forms_responders`;
CREATE TABLE `forms_responders` (
  `responder_id` mediumint(8) unsigned NOT NULL default '0',
  `form_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`responder_id`,`form_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Auto-responders assigned to mailing lists';

--
-- Dumping data for table `forms_responders`
--

LOCK TABLES `forms_responders` WRITE;
/*!40000 ALTER TABLE `forms_responders` DISABLE KEYS */;
/*!40000 ALTER TABLE `forms_responders` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `grants`
--

DROP TABLE IF EXISTS `grants`;
CREATE TABLE `grants` (
  `user_id` mediumint(8) unsigned NOT NULL,
  `right_id` tinyint(3) unsigned NOT NULL default '0',
  `object_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`user_id`,`right_id`,`object_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Access rights granted to users';

--
-- Dumping data for table `grants`
--

LOCK TABLES `grants` WRITE;
/*!40000 ALTER TABLE `grants` DISABLE KEYS */;
INSERT INTO `grants` VALUES (2,1,0),(2,2,0),(2,3,0);
/*!40000 ALTER TABLE `grants` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `groups`
--

DROP TABLE IF EXISTS `groups`;
CREATE TABLE `groups` (
  `group_id` mediumint(8) unsigned NOT NULL auto_increment,
  `name` varchar(32) default NULL,
  `anonymous` enum('Y','N') NOT NULL default 'N',
  PRIMARY KEY  (`group_id`),
  KEY `i_group_anon` (`anonymous`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `groups`
--

LOCK TABLES `groups` WRITE;
/*!40000 ALTER TABLE `groups` DISABLE KEYS */;
INSERT INTO `groups` VALUES (1,'Anonymous users','Y'),(2,'Members','N'),(3,'Administrators','N'),(4,'Job Members','N');
/*!40000 ALTER TABLE `groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `link_clicks`
--

DROP TABLE IF EXISTS `link_clicks`;
CREATE TABLE `link_clicks` (
  `link_id` mediumint(8) unsigned NOT NULL,
  `clicks` mediumint(8) unsigned default '0',
  `views` mediumint(8) unsigned default '0',
  `stat_id` mediumint(8) unsigned NOT NULL,
  `user_ip` varchar(16) NOT NULL default '0',
  PRIMARY KEY  (`link_id`,`stat_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Count of click-thru on email links';

--
-- Dumping data for table `link_clicks`
--

LOCK TABLES `link_clicks` WRITE;
/*!40000 ALTER TABLE `link_clicks` DISABLE KEYS */;
/*!40000 ALTER TABLE `link_clicks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `link_user`
--

DROP TABLE IF EXISTS `link_user`;
CREATE TABLE `link_user` (
  `link_id` mediumint(8) unsigned NOT NULL default '0',
  `stat_id` mediumint(8) unsigned NOT NULL default '0',
  `email` varchar(254) NOT NULL default '',
  PRIMARY KEY  (`link_id`,`stat_id`,`email`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='users of click-thru on email links';

--
-- Dumping data for table `link_user`
--

LOCK TABLES `link_user` WRITE;
/*!40000 ALTER TABLE `link_user` DISABLE KEYS */;
/*!40000 ALTER TABLE `link_user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mysql_ok`
--

DROP TABLE IF EXISTS `mysql_ok`;
CREATE TABLE `mysql_ok` (
  `b` bigint(20) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `mysql_ok`
--

LOCK TABLES `mysql_ok` WRITE;
/*!40000 ALTER TABLE `mysql_ok` DISABLE KEYS */;
/*!40000 ALTER TABLE `mysql_ok` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `nav_fields`
--

DROP TABLE IF EXISTS `nav_fields`;
CREATE TABLE `nav_fields` (
  `field_id` int(11) unsigned NOT NULL auto_increment,
  `last_fld_id` int(11) default NULL,
  `nav_id` tinyint(3) unsigned NOT NULL default '0',
  `form_id` int(11) NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `required` tinyint(4) NOT NULL default '0',
  `active` tinyint(4) NOT NULL default '1',
  `search` tinyint(4) NOT NULL default '0',
  `modify` tinyint(4) NOT NULL default '1',
  `type` tinyint(4) NOT NULL default '0',
  `sort` tinyint(3) unsigned NOT NULL default '255',
  `empty_default` tinyint(3) unsigned NOT NULL default '1',
  `date_start` smallint(5) unsigned NOT NULL default '0',
  `date_end` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`field_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `nav_fields`
--

LOCK TABLES `nav_fields` WRITE;
/*!40000 ALTER TABLE `nav_fields` DISABLE KEYS */;
/*!40000 ALTER TABLE `nav_fields` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `navgroup_names`
--

DROP TABLE IF EXISTS `navgroup_names`;
CREATE TABLE `navgroup_names` (
  `navgroup_id` tinyint(3) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`navgroup_id`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `navgroup_names`
--

LOCK TABLES `navgroup_names` WRITE;
/*!40000 ALTER TABLE `navgroup_names` DISABLE KEYS */;
INSERT INTO `navgroup_names` VALUES (1,'Miscellaneous pages for all customization options'),(2,'These pages are for the Standard Registration Form'),(3,'These pages are for the \"Create Subscriber Text Box\" option'),(4,'These pages are for the Login Manager'),(5,'These pages are for the Survey Forms');
/*!40000 ALTER TABLE `navgroup_names` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `navlinks`
--

DROP TABLE IF EXISTS `navlinks`;
CREATE TABLE `navlinks` (
  `nav_id` int(11) unsigned NOT NULL auto_increment,
  `navgroup` tinyint(4) NOT NULL default '0',
  `navname` varchar(255) NOT NULL default '',
  `form_id` varchar(255) NOT NULL default '0',
  `added` datetime NOT NULL default '0000-00-00 00:00:00',
  `header` mediumblob,
  `header_html` text,
  `header_align` tinyint(4) NOT NULL default '1',
  `footer` mediumblob,
  `footer_html` text,
  `footer_align` tinyint(4) NOT NULL default '1',
  `no_footer` tinyint(3) unsigned NOT NULL default '0',
  `logo_bg` varchar(32) NOT NULL default '#ffffff',
  `footer_text` text,
  `active` tinyint(3) unsigned NOT NULL default '1',
  `popup` tinyint(3) unsigned NOT NULL default '1',
  `outline_border` tinyint(3) unsigned NOT NULL default '1',
  `auto_subscribe` tinyint(3) unsigned NOT NULL default '1',
  `approve_members` tinyint(3) unsigned NOT NULL default '0',
  `confirm_email` tinyint(3) unsigned NOT NULL default '0',
  `preview` tinyint(3) unsigned NOT NULL default '0',
  `signup_redirect` varchar(255) NOT NULL default '',
  `header_img` mediumblob,
  `modify_profile` tinyint(3) unsigned NOT NULL default '1',
  `header_color` varchar(32) NOT NULL default '#0000ff',
  `footer_color` varchar(32) NOT NULL default '#f4f4f4',
  `header_text` varchar(255) NOT NULL default 'Please Join our Mailing List',
  `text_color` varchar(32) NOT NULL default '#ffffff',
  `confirm_bg_color` varchar(32) NOT NULL default '#000099',
  `confirm_color` varchar(32) NOT NULL default '#FF0000',
  `text_color2` varchar(32) NOT NULL default '#000000',
  `bg_color` varchar(32) NOT NULL default '#cccccc',
  `bg_color_table` varchar(32) NOT NULL default '#FFFFFF',
  `border_table` varchar(32) NOT NULL default '#E1E1E1',
  `heading1` varchar(255) NOT NULL default 'Newsletter Registration',
  `heading2` varchar(255) NOT NULL default 'Thank you for registering for our Mailing List. The email that will be subscribed is %email%.',
  `heading5` varchar(255) NOT NULL default 'Profile Information',
  `heading6` varchar(255) NOT NULL default 'Please provide us with the following information:',
  `submit` mediumblob,
  `cancel` mediumblob,
  PRIMARY KEY  (`nav_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `navlinks`
--

LOCK TABLES `navlinks` WRITE;
/*!40000 ALTER TABLE `navlinks` DISABLE KEYS */;
INSERT INTO `navlinks` VALUES (1,2,'','0','0000-00-00 00:00:00','\0JFIF\0\0H\0H\0\0\0C\0		\n\n\n\n          \0C\r\r\Z\Z                                                 \0\0]\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0I\0\0\0\0\0!1\"AQ2aBq#37R$6Cbrstu%\'4cᢲ\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0*\0\0\0\0\0\0\0!1Aa\"QqR2Bb\0\0\0?\0S@P(\n@P(\n@P(\n@P(\n@P(\n@P(\n@P(\n@P(\n@.q4IAcu8֭ueyFUXPTTؗzMIrz-@ԤzVgz[Vm\n@P(\n@P(\n@P(\n2\rߛL)c$WUӋ:}_v\0SN9g\Z \\GT\0g.ԶI$0vyχ^pQGD7@ʱj&\\}Rc[t=	-~W\'Ew[5㎗߳!qiüfd(d?,NFMgPhF֠18`?9M~/#\\ٱrUB@P(\n@P(\n@P(\n	A[I=>}h<HY5}e&mjv(*bLwAi={48R*+SoT>/5IqxcbទՖ++leHT#TAH\nׯԞZt1}EC/(/~-mhWdtU1ӏoKr欶òGzl(tuHGzfmXFi]?oR@ۍƖ3G3֭LǸV}J\r2cBaGf0>ߙ6ϖG\n@P(\n@P(\n@P(*%\rۓ̸m67$1c:S%?77wV8?	ܣԜIXt6۽[jnd! :Y	U_y\\\'zz\\[g4D5,VWFғN]̓c\'\0)cԵyb8HԨ.nє).\'lw+usu8͢\0jxKхnV嶅u)Q;5޶կwUZR9;ޝ%h}:zv=욆+BPZP(3wXENEC\ncI\n i1~.Kj>Ztbv؃Tf8ch2mE8[J&nY	Ozm\nBF㌓}P(\n]Dv\\U	qSKOQ\r=@P(\nDqz$oaOWJΧh$Z{p--8R˽\\wjLn^l\0)8-,?b\\VS;#nH \0cdDu\nΠ~<4u>uoa@ikVg.ͅ׈,\Z ngQrIeJm{w\0tZtߴ-qn=a\0\r(Hr2#WLR\rpӶs»kV&e{,7\')P:NS,:)\\S@Y\Z	xnw+fjE-\\ynGCM*Q8%kRN\0кMw}Z̎9I=}R}޴,RU	\Z?Xx]/mw0642p5/vkN[o|s\nqHx0RY5өT|40ܒu-E\\.حGNtAw=Ja=:?n0\"]i\n4:{}v4:k:!{T]P%&;;`BSz/jGٱxĂIN\0?+m篮sI&穭bf5zT;g,¹+-Y&(g./\n$fIm幯g]odgiBzI~ݡGֶ!A91vWnFЊiFղ\\=-lKr❔HX\0\n8=h7:vU],dødFGP}0h,h\nA\"C[KL2BR̚/6<`at9v3AD}o\Z^qqS\\O=WZxp>V\Z_P4^&)1:.qmC>LG~e>t\r[-\0g5{ogvm%NM^R:{~m0[dv|FR\\	^Fp\Z-eFSSg_ ,&(JZ{X۟pIg\\\0P4kW\0fP8Y?<jaA.fnC)GR\0Ay]`a$[DB<*YABPQL_Wh!/O\'Op\r/)18yCi;ˮvM36\nA2Xfwݷ9\\c:1J8H$\">$ZrS+	甠>T\\eO1xwy``d%VCw_$D_Zs`qjTCdTesZ@Z[RU楦&iָ{0[\0{$B;[iJޜ#b\0W%\n&]O#Rh9(\r%m>6q}@P(n%ۭ:%[-k:ۊ\0޺\\_?1M<MmjmĔ8!C^JZnWI\"-:>~o=k3g7Er&N>K_sc?/[]O?J7d&D6vshHh?].^Uu8į81ax#}5[Ztzy&w\nl\\l>ȹM[6.>*/lj\Z\Z#w?!ùt\r\'nκ̈v ʒ))Jʔ#jS=@i;t\rEq2ʙs	KYIll\0\r$(v&`vȎ<o!ҒJ68s4li4g.]q 9iJ{vX4;=,e!Mn\\\'$AѦO\r)rD2VT$YW3jP3˽	1$kA?47\riiȺ~S\'+kO4Q;J^u\0vh4\ZÇMS+SNȏ!\0dvJtWnbr}Co\n\0`;IƖ=Y!iwJS\rT&&\rɣh8##tŦd\\dGǆ$% gozP]]4=`W}3Kl 4BT\r(o<].9>sBsL!l*\'=7 qA٭[c{|$NM@P(3:ƦHJ}$sחW\0~>ԍ1ɂ햛m0ȍOr~fZV)5E\"N\":?mk\'m\\|7fncmF2?=V~U~VqӌiѬRn]*P%J<!%\'iڔe\ZOlK9	/a	a	\ny$mLq:]ZoWj)VWu\rfmW8tHYR0p}jr[ohǖZuk6(Rm>XK;ksťdCSѦyHoZ款]n[n#m&l/.JC~lֱ[յUFs_DFsnͲwAO}3V<o[Wןz\\kmI&knLfR<);+,\\8^so/)rTUd9Ds33׷#D?A	8W3vݻoU[8o>׶/Pk	\ZjLʕ⹡JQ7)d9\\CLtHvŹZ\'҃V9j|kjy}Vvup,bY6;uK3VL4~[{ڕ0]YJ70oUqcƜE$5eHeI.(+-w9kpFyԺgq\n\rʜu];xiNpI=1S^&cNyΓ^kD.9gcyl\ZS-(r?w	1ԴwZWFѲuvlq)<Х{+SRo6x)n7iW-7EEdcʰ^\\+ߟu䙶_ח+e0VZ@PZTUZTǞf÷!QQhedIQs=y9qkǭsiiD_BI}{W׾l߳}]j5Kq\r+)trnh^R~xKv/_S~ۦlm(or)\'cQ)銵hQ\\bZ]\'wxRR?!*+K`YOLOzN6lV]6@P(*\"~G/b$#VrR{\'ڵ~6ܳNU&^;a#2\n6Rzs\nc5lu>tr.:z,P$8AIPOQj~PcŪqgvԍ=&Dd62?*7Sg_\\w\ZJsI-Ww\Z]ͷ-ۓ\nhpԩ%6qUh췥j3@UlJٔ.Mܥ2KiXJp\nW+8\'_;MƤӆoKy=N8_Y&=1:z[.s8R\"tJ{͖/15>x[/|$L\0O33n=v\0WcoNlΡ]-[40խ	@		qe_k?ź}֮.o\n~ ;Sh\rJ&\r:pKL!@$|GV7VznzjC¯\ng3~qV~6eAIwTo0i[.\\YQPܶ:	9%\'qQ^mꉇc:cQÏwLEAqwReQϑVq4o}>~;˛>\n|L,\"+*[e\0 =zvxDG1Yw\\tOӧPBjYaa*eJ봫zyj+#\'/d>>wH\'.¨ѢOaJZBd%*[׉%_Fb~xFoj\"\'7s\nqCi۹_*w~Zטh\\KVn߄DQ+1`>z|}ׇUsn].:Nɍ\\t$1{{V8~6ngƮHlE\"8V\"t*Gm=ZWbvN\0-i\0H^q֓.]ˍYQB351DL}5$?:N&ϧd~:T)겮	>Նk\ZoY(\n@P(\n@P(\n@P(\n@P',NULL,1,NULL,NULL,1,0,'#ffffff','',1,1,1,1,0,0,0,'',NULL,1,'#0000ff','#f4f4f4','Please Join our Mailing List','#ffffff','#000099','#FF0000','#000000','#cccccc','#FFFFFF','#E1E1E1','Newsletter Registration','Thank you for registering for our Mailing List. The email that will be subscribed is %email%.','Profile Information','Please provide us with the following information:',NULL,NULL);
/*!40000 ALTER TABLE `navlinks` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `okcode`
--

DROP TABLE IF EXISTS `okcode`;
CREATE TABLE `okcode` (
  `id` int(11) NOT NULL auto_increment,
  `code` varchar(11) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='code';

--
-- Dumping data for table `okcode`
--

LOCK TABLES `okcode` WRITE;
/*!40000 ALTER TABLE `okcode` DISABLE KEYS */;
/*!40000 ALTER TABLE `okcode` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pages`
--

DROP TABLE IF EXISTS `pages`;
CREATE TABLE `pages` (
  `page_id` smallint(5) unsigned NOT NULL auto_increment,
  `name` varchar(32) NOT NULL,
  `description` varchar(255) NOT NULL default '',
  `mode` varchar(32) NOT NULL default '',
  `buttons_no` tinyint(4) NOT NULL default '0',
  `navgroup` tinyint(4) NOT NULL default '0',
  `button1` varchar(255) NOT NULL default '',
  `button2` varchar(255) NOT NULL default '',
  `button3` varchar(255) NOT NULL default '',
  `button4` varchar(255) NOT NULL default '',
  `has_form` tinyint(3) unsigned NOT NULL default '0',
  `has_close` tinyint(3) unsigned NOT NULL default '0',
  `table_nr` tinyint(3) unsigned NOT NULL default '0',
  `hits` mediumint(8) unsigned NOT NULL default '0',
  `last_visit` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`page_id`),
  KEY `i_pages_name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=20 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `pages`
--

LOCK TABLES `pages` WRITE;
/*!40000 ALTER TABLE `pages` DISABLE KEYS */;
INSERT INTO `pages` VALUES (1,'/users/register.php','This page is used if from the Customize User Interface you\r\nchoose the option \"Create Standard Registation Form\"','',1,2,'Register','','','',1,0,1,0,'0000-00-00 00:00:00'),(2,'/users/thankyou.php','This is the page users will get sent to when they complete the form.','',0,2,'','','','',0,1,0,0,'0000-00-00 00:00:00'),(3,'/users/index.php','Main page','',0,0,'','','','',0,0,0,0,'0000-00-00 00:00:00'),(4,'/users/members.php','Login page (membership services)','',2,4,'Login','New User','','',0,0,0,0,'0000-00-00 00:00:00'),(5,'/users/unsubscribe.php','This page is used for users to un-subscribe.','',0,1,'','','','',0,0,0,0,'0000-00-00 00:00:00'),(6,'/users/lostpassword.php','If users are loose their password they will be able to\r\nretreive there password from this page.','',0,4,'','','','',0,0,0,0,'0000-00-00 00:00:00'),(7,'/users/lostpassword.php','This is step 2 from the lost password page.','check_x',0,4,'','','','',0,0,0,0,'0000-00-00 00:00:00'),(8,'/users/profile.php','Modify Profile page','',0,1,'','','','',0,0,0,0,'0000-00-00 00:00:00'),(9,'/users/profile.php','Modify Profile page - step 2','check',0,1,'','','','',0,0,0,0,'0000-00-00 00:00:00'),(10,'/users/email_exist.php','This is the page used when users modify their profile.','',0,3,'','','','',0,0,0,0,'0000-00-00 00:00:00'),(11,'/users/email_exist.php','This is step 2 of the page users use when they modify their profile.','check_x',0,3,'','','','',0,0,0,0,'0000-00-00 00:00:00'),(12,'/users/share_friends.php','You have the option to allow users to share emails with their friends.','',0,1,'','','','',0,0,0,0,'0000-00-00 00:00:00'),(13,'/users/share_friends.php','Step 2 for the share email with friends page.','check',0,1,'','','','',0,0,0,0,'0000-00-00 00:00:00'),(14,'/users/register2.php','This page is used if you choose the \"Create Subscriber Text Box\" on the Customize User Interface Page.','',0,3,'','','','',1,0,1,0,'0000-00-00 00:00:00'),(15,'/users/validate.php','This page is used for users to confirm their email if the\r\noption is selected for users to confirm their email','',0,1,'','','','',0,0,0,0,'0000-00-00 00:00:00'),(16,'/users/bye.php','This page is used when users log out.','',0,1,'','','','',0,0,0,0,'0000-00-00 00:00:00'),(17,'/users/survey.php','Survey Page','',1,5,'Submit Survey','','','',1,0,0,0,'0000-00-00 00:00:00'),(18,'/users/survey.php','Survey Confirmation Page','check_x',0,5,'','','','',0,0,0,0,'0000-00-00 00:00:00'),(19,'/users/thankyou.php','This is the page users will get sent to when they complete the form.','',0,3,'','','','',0,1,0,0,'0000-00-00 00:00:00');
/*!40000 ALTER TABLE `pages` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pages_properties`
--

DROP TABLE IF EXISTS `pages_properties`;
CREATE TABLE `pages_properties` (
  `page_id` mediumint(8) unsigned NOT NULL,
  `form_id` varchar(50) NOT NULL default '0',
  `nav_id` int(11) unsigned NOT NULL default '0',
  `cust_id` int(11) unsigned NOT NULL default '0',
  `object_id` mediumint(8) unsigned NOT NULL default '0',
  `background` varchar(32) NOT NULL default '#cccccc',
  `title` varchar(255) NOT NULL default '',
  `meta` text,
  `header` text,
  `subtitle` text,
  `footer` text,
  `image1` mediumblob,
  `image2` mediumblob,
  `image3` mediumblob,
  `image4` mediumblob,
  `image5` mediumblob,
  `bg_image` mediumblob,
  `font_color` varchar(255) NOT NULL default 'black',
  `font_size` varchar(255) NOT NULL default '12',
  `table_color` varchar(32) NOT NULL default '#4064B0',
  `has_close` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`page_id`,`form_id`,`object_id`,`nav_id`,`cust_id`),
  KEY `i_pages_properties_object` (`object_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `pages_properties`
--

LOCK TABLES `pages_properties` WRITE;
/*!40000 ALTER TABLE `pages_properties` DISABLE KEYS */;
INSERT INTO `pages_properties` VALUES (3,'0',1,0,0,'#cccccc','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'black','12','#4064B0',1),(5,'0',1,0,0,'#cccccc','',NULL,'<p><b>You have successfully un-subscribed your email.</b>',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'black','12','#4064B0',1),(6,'0',1,0,0,'#cccccc','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'black','12','#4064B0',1),(7,'0',1,0,0,'#cccccc','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'black','12','#4064B0',1),(10,'0',1,0,0,'#cccccc','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'black','12','#4064B0',1),(11,'0',1,0,0,'#cccccc','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'black','12','#4064B0',1),(12,'0',1,0,0,'#cccccc','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'black','12','#4064B0',1),(13,'0',1,0,0,'#cccccc','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'black','12','#4064B0',1),(14,'0',1,0,0,'#cccccc','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'black','12','#4064B0',1),(15,'0',1,0,0,'#cccccc','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'black','12','#4064B0',1),(16,'0',1,0,0,'#cccccc','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'black','12','#4064B0',1),(17,'0',1,0,0,'#cccccc','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'black','12','#4064B0',1),(18,'0',1,0,0,'#cccccc','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'black','12','#4064B0',1);
/*!40000 ALTER TABLE `pages_properties` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `payment_gateways`
--

DROP TABLE IF EXISTS `payment_gateways`;
CREATE TABLE `payment_gateways` (
  `gateway_id` tinyint(3) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY  (`gateway_id`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=latin1 COMMENT='Payment Gateways';

--
-- Dumping data for table `payment_gateways`
--

LOCK TABLES `payment_gateways` WRITE;
/*!40000 ALTER TABLE `payment_gateways` DISABLE KEYS */;
INSERT INTO `payment_gateways` VALUES (1,'None'),(2,'Authorize.Net'),(3,'BluePay'),(4,'VeriSign Payflow Link'),(5,'VeriSign Payflow Pro');
/*!40000 ALTER TABLE `payment_gateways` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `responder_fields`
--

DROP TABLE IF EXISTS `responder_fields`;
CREATE TABLE `responder_fields` (
  `responder_id` int(11) NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  `value2` varchar(255) NOT NULL default '',
  `form_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`responder_id`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Auto-responders based on customize fields';

--
-- Dumping data for table `responder_fields`
--

LOCK TABLES `responder_fields` WRITE;
/*!40000 ALTER TABLE `responder_fields` DISABLE KEYS */;
/*!40000 ALTER TABLE `responder_fields` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `responder_reads`
--

DROP TABLE IF EXISTS `responder_reads`;
CREATE TABLE `responder_reads` (
  `read_id` mediumint(8) unsigned NOT NULL auto_increment,
  `responder_id` mediumint(8) unsigned NOT NULL default '0',
  `email` varchar(255) NOT NULL default '',
  `d` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`read_id`),
  KEY `i_responder_reads_email` (`email`),
  KEY `i_responder_reads_responder` (`responder_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stats on who and when read auto-responder emails';

--
-- Dumping data for table `responder_reads`
--

LOCK TABLES `responder_reads` WRITE;
/*!40000 ALTER TABLE `responder_reads` DISABLE KEYS */;
/*!40000 ALTER TABLE `responder_reads` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `responder_subscribes`
--

DROP TABLE IF EXISTS `responder_subscribes`;
CREATE TABLE `responder_subscribes` (
  `responder_id` mediumint(8) unsigned NOT NULL default '0',
  `contact_id` mediumint(8) unsigned NOT NULL default '0',
  `form_id` mediumint(8) unsigned NOT NULL default '0',
  `added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`responder_id`,`contact_id`,`form_id`),
  KEY `contact_id` (`contact_id`),
  KEY `form_id` (`form_id`),
  KEY `added` (`added`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Contacts subscribed to auto-responders';

--
-- Dumping data for table `responder_subscribes`
--

LOCK TABLES `responder_subscribes` WRITE;
/*!40000 ALTER TABLE `responder_subscribes` DISABLE KEYS */;
/*!40000 ALTER TABLE `responder_subscribes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rights`
--

DROP TABLE IF EXISTS `rights`;
CREATE TABLE `rights` (
  `right_id` tinyint(3) unsigned NOT NULL auto_increment,
  `name` varchar(128) NOT NULL,
  `object` varchar(32) NOT NULL default '',
  `object_id` mediumint(8) unsigned NOT NULL default '0',
  `display_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`right_id`),
  KEY `i_rights_object_id` (`object_id`)
) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=latin1 COMMENT='Types of access rights';

--
-- Dumping data for table `rights`
--

LOCK TABLES `rights` WRITE;
/*!40000 ALTER TABLE `rights` DISABLE KEYS */;
INSERT INTO `rights` VALUES (1,'Administration Management','',0,''),(2,'Manage Administrator Users','',0,''),(3,'Send Emails','',0,''),(4,'View contacts','forms',0,'User Can View Email Lists'),(5,'Edit contacts','forms',0,'User Can Edit Email Lists'),(6,'Delete contacts','forms',0,'User Can Delete Email Lists');
/*!40000 ALTER TABLE `rights` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `session`
--

DROP TABLE IF EXISTS `session`;
CREATE TABLE `session` (
  `session_id` bigint(20) NOT NULL auto_increment,
  `hash` char(32) NOT NULL default '',
  `user_id` mediumint(8) unsigned NOT NULL default '0',
  `ip` char(16) NOT NULL default '',
  `start_time` bigint(20) unsigned NOT NULL default '0',
  `end_time` bigint(20) unsigned NOT NULL default '0',
  `visited_pages` mediumint(9) NOT NULL default '0',
  `useragent` varchar(255) NOT NULL default '',
  `captcha` varchar(255) default NULL,
  PRIMARY KEY  (`session_id`),
  KEY `i_session_user_id` (`user_id`),
  KEY `i_session_hash` (`hash`),
  KEY `i_session_ip` (`ip`),
  KEY `i_session_start` (`start_time`),
  KEY `i_session_end` (`end_time`),
  KEY `i_session_visits` (`visited_pages`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `session`
--

LOCK TABLES `session` WRITE;
/*!40000 ALTER TABLE `session` DISABLE KEYS */;
INSERT INTO `session` VALUES (1,'efb93677b441f6e580493cb3110e25a9',2,'192.168.62.207',1205726754,1205726764,2,'Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.8.1.12) Gecko/20080201 Firefox/2.0.0.12',NULL);
/*!40000 ALTER TABLE `session` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `states`
--

DROP TABLE IF EXISTS `states`;
CREATE TABLE `states` (
  `code` char(2) NOT NULL,
  `name` varchar(60) default NULL,
  PRIMARY KEY  (`code`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `states`
--

LOCK TABLES `states` WRITE;
/*!40000 ALTER TABLE `states` DISABLE KEYS */;
INSERT INTO `states` VALUES ('AL','Alabama'),('AK','Alaska'),('AZ','Arizona'),('AR','Arkansas'),('CA','California'),('CO','Colorado'),('CT','Connecticut'),('DE','Delaware'),('DC','District of Columbia'),('FL','Florida'),('GA','Georgia'),('HI','Hawaii'),('ID','Idaho'),('IL','Illinois'),('IN','Indiana'),('IA','Iowa'),('KS','Kansas'),('KY','Kentucky'),('LA','Louisiana'),('ME','Maine'),('MD','Maryland'),('MA','Massachusetts'),('MI','Michigan'),('MN','Minnesota'),('MS','Mississippi'),('MO','Missouri'),('MT','Montana'),('NE','Nebraska'),('NV','Nevada'),('NH','New Hampshire'),('NJ','New Jersey'),('NM','New Mexico'),('NY','New York'),('NC','North Carolina'),('ND','North Dakota'),('OH','Ohio'),('OK','Oklahoma'),('OR','Oregon'),('PA','Pennsylvania'),('RI','Rhode Island'),('SC','South Carolina'),('SD','South Dakota'),('TN','Tennessee'),('TX','Texas'),('UT','Utah'),('VT','Vermont'),('VA','Virginia'),('WA','Washington'),('WV','West Virginia'),('WI','Wisconsin'),('WY','Wyoming');
/*!40000 ALTER TABLE `states` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `survey_fields`
--

DROP TABLE IF EXISTS `survey_fields`;
CREATE TABLE `survey_fields` (
  `field_id` tinyint(4) NOT NULL auto_increment,
  `survey_id` mediumint(8) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `required` tinyint(4) NOT NULL default '0',
  `active` tinyint(4) NOT NULL default '1',
  `type` tinyint(4) NOT NULL default '0',
  `empty_default` tinyint(3) unsigned NOT NULL default '0',
  `report` tinyint(4) NOT NULL default '1',
  `date_start` smallint(5) unsigned NOT NULL default '0',
  `date_end` smallint(5) unsigned NOT NULL default '0',
  `sort` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`field_id`),
  KEY `i_survey_fields_survey` (`survey_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Custom survey fields';

--
-- Dumping data for table `survey_fields`
--

LOCK TABLES `survey_fields` WRITE;
/*!40000 ALTER TABLE `survey_fields` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_fields` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `surveys`
--

DROP TABLE IF EXISTS `surveys`;
CREATE TABLE `surveys` (
  `survey_id` mediumint(8) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `show_border` tinyint(3) unsigned NOT NULL default '1',
  `header` mediumblob,
  `header_html` text,
  `header_align` tinyint(4) NOT NULL default '1',
  `footer` mediumblob,
  `footer_html` text,
  `footer_align` tinyint(4) NOT NULL default '1',
  `no_footer` tinyint(3) unsigned NOT NULL default '0',
  `logo_bg` varchar(32) NOT NULL default '#ffffff',
  `popup` tinyint(3) unsigned NOT NULL default '1',
  `outline_border` tinyint(3) unsigned NOT NULL default '1',
  PRIMARY KEY  (`survey_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='List of surveys';

--
-- Dumping data for table `surveys`
--

LOCK TABLES `surveys` WRITE;
/*!40000 ALTER TABLE `surveys` DISABLE KEYS */;
/*!40000 ALTER TABLE `surveys` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `system_email_templates`
--

DROP TABLE IF EXISTS `system_email_templates`;
CREATE TABLE `system_email_templates` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `subject` varchar(255) NOT NULL default '',
  `content` text,
  `comment` varchar(255) NOT NULL default '',
  `from_name` varchar(255) NOT NULL default '',
  `from_email` varchar(255) NOT NULL default '',
  `active` tinyint(3) unsigned NOT NULL default '1',
  `return_path` varchar(255) NOT NULL default '',
  `reply_to` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `system_email_templates`
--

LOCK TABLES `system_email_templates` WRITE;
/*!40000 ALTER TABLE `system_email_templates` DISABLE KEYS */;
INSERT INTO `system_email_templates` VALUES (1,'bounce notify','Bounce notify: {email}','This email is to notify you that the following email bounced\r\nwhen it was sent off from your etools:\r\n\r\n{email}\r\n\r\nPlease check your support desk under\r\ncontact manager -> bounce email manager to see how this email\r\nwas handled.','lib/bounce.php','','noreply@@@BASE_URL_HOST@@',1,'',''),(2,'New user','New user signed up at mailer','Email: {email}\nEmail List Name: {email_list}\n\nSee details at this page:\r\n@@ROOT_URL@@/admin/contacts.php?form_id={form_id}&op=edit&id={contact_id}','users/thankyou.php','','noreply@@@BASE_URL_HOST@@',1,'',''),(3,'profile modified','{username} has modified their profile','{username} has modified their profile.\r\nYou may get details here: @@ROOT_URL@@/admin/contacts.php?op=edit&id={contact_id}&form_id={form_id}','users/profile.php','','noreply@@@BASE_URL_HOST@@',1,'',''),(4,'profile modified2','{username} has modified their profile','{username} has modified their profile.\r\nYou may get details here: @@ROOT_URL@@/admin/contacts.php?op=edit&id={contact_id}&form_id={form_id}','users/email_exist.php','','noreply@@@BASE_URL_HOST@@',1,'',''),(5,'statistics','Statistics from mail campaign','The campaign {campaign_name} has finished sending at {end}.\r\n    Below are the statistics.\r\n\r\n    Campaign Name: {campaign_name}\r\n    Campaign ID: {id}\r\n    Start Time: {start}\r\n    Finish Time: {end}\r\n    The total recipients: {sent}','admin/thread.php','','noreply@@@BASE_URL_HOST@@',1,'',''),(6,'un-subscribed email','{email} un-subscribed','The {email} has un-subscribed\r\nfrom your mailing system. You can review the following link at:\r\n\r\n@@ROOT_URL@@/admin/contacts.php?form_id={form_id}&op=edit&id={contact_id}&user={adm_user}&password={pw}','users/unsubscribe.php','','noreply@@@BASE_URL_HOST@@',1,'',''),(7,'validate email','Validate your email','{f_text}\\n\\n@@ROOT_URL@@/users/validate.php?id={hash}','admin/advanced_mgmt.php','','{f_from}',1,'',''),(8,'Email After User Confirms','Email Confirmed','You have successfully been added to our email list.\r\n\r\nEmail: %email%','','','noreply@@@BASE_URL_HOST@@',1,'',''),(9,'Confirm User Email','Confirm Your Email','Hi,\r\n\r\nWe received a request to add you to our email list named\r\n%email_list_name%. Please click on the link below to approve\r\nthis request.\r\n\r\n%link%','','','noreply@@@BASE_URL_HOST@@',1,'','');
/*!40000 ALTER TABLE `system_email_templates` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `system_emails`
--

DROP TABLE IF EXISTS `system_emails`;
CREATE TABLE `system_emails` (
  `email_id` tinyint(3) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `from_addr` varchar(255) NOT NULL default '',
  `subject` varchar(255) NOT NULL default '',
  `body` text,
  PRIMARY KEY  (`email_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 COMMENT='System-generated emails come from the database';

--
-- Dumping data for table `system_emails`
--

LOCK TABLES `system_emails` WRITE;
/*!40000 ALTER TABLE `system_emails` DISABLE KEYS */;
INSERT INTO `system_emails` VALUES (1,'Password Recovery Email','','Password Recovery Email','The requested login and password is below.\r\n\r\nYour login: $(login)\r\nYour password: $(password)\r\n\r\nThanks,\r\nSupport'),(2,'Survey results','','Survey %survey_name% results from %user%','Survey results from %user%:\r\n%results%');
/*!40000 ALTER TABLE `system_emails` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `threads`
--

DROP TABLE IF EXISTS `threads`;
CREATE TABLE `threads` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `last_update` datetime NOT NULL default '0000-00-00 00:00:00',
  `stats_id` mediumint(8) unsigned NOT NULL default '0',
  `status` enum('start','init','run','paused','waiting','finished','aborted') NOT NULL default 'start',
  `local_no` tinyint(4) NOT NULL default '0',
  `smtp` varchar(30) NOT NULL default '',
  `counter` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `threads`
--

LOCK TABLES `threads` WRITE;
/*!40000 ALTER TABLE `threads` DISABLE KEYS */;
/*!40000 ALTER TABLE `threads` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user`
--

DROP TABLE IF EXISTS `user`;
CREATE TABLE `user` (
  `user_id` mediumint(8) unsigned NOT NULL auto_increment,
  `form_id` mediumint(8) unsigned NOT NULL default '0',
  `cust_id` mediumint(8) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `password` char(32) NOT NULL default '',
  `firstname` varchar(64) NOT NULL default '',
  `lastname` varchar(64) NOT NULL default '',
  `email` varchar(255) NOT NULL default '',
  `notify` tinyint(3) unsigned NOT NULL default '0',
  `test_email` tinyint(3) unsigned NOT NULL default '0',
  `notify_unsub` tinyint(3) unsigned NOT NULL default '1',
  `user_created` datetime NOT NULL default '0000-00-00 00:00:00',
  `isReminder` enum('0','1') NOT NULL default '0',
  `reminder_date` date NOT NULL default '0000-00-00',
  `reminder_from` varchar(255) NOT NULL default '',
  `reminder_text` varchar(255) NOT NULL default '',
  `reminder_sent` tinyint(3) NOT NULL default '0',
  PRIMARY KEY  (`user_id`),
  KEY `i_user_name` (`name`),
  KEY `i_user_password` (`password`),
  KEY `i_user_form` (`form_id`),
  KEY `i_user_notify_unsub` (`notify_unsub`),
  KEY `i_user_notify_email` (`email`),
  KEY `i_user_notify_user_created` (`user_created`),
  KEY `i_user_notify_isReminder` (`isReminder`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

--
-- Dumping data for table `user`
--

LOCK TABLES `user` WRITE;
/*!40000 ALTER TABLE `user` DISABLE KEYS */;
INSERT INTO `user` VALUES (1,0,0,'guest','','DO NOT TOUCH !!!','BUILTIN ACCOUNT','',0,0,1,'0000-00-00 00:00:00','0','0000-00-00','','',0),(2,0,0,'@@ADMIN_NAME@@','@@ADMIN_PASSWORD@@','Main Administrator','','@@ADMIN_EMAIL@@',1,1,1,'2008-03-17 10:03:14','0','0000-00-00','','',0);
/*!40000 ALTER TABLE `user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user_group`
--

DROP TABLE IF EXISTS `user_group`;
CREATE TABLE `user_group` (
  `user_id` mediumint(8) unsigned NOT NULL,
  `group_id` mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`user_id`,`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `user_group`
--

LOCK TABLES `user_group` WRITE;
/*!40000 ALTER TABLE `user_group` DISABLE KEYS */;
INSERT INTO `user_group` VALUES (1,1),(2,3);
/*!40000 ALTER TABLE `user_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `validate_emails`
--

DROP TABLE IF EXISTS `validate_emails`;
CREATE TABLE `validate_emails` (
  `form_id` mediumint(8) unsigned NOT NULL default '0',
  `contact_id` mediumint(8) unsigned NOT NULL default '0',
  `hash` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`form_id`,`contact_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Temporary table with emails pending for validation';

--
-- Dumping data for table `validate_emails`
--

LOCK TABLES `validate_emails` WRITE;
/*!40000 ALTER TABLE `validate_emails` DISABLE KEYS */;
/*!40000 ALTER TABLE `validate_emails` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2008-03-17  4:09:12
